/*!
 * Application Insights JavaScript SDK - Web Analytics, 3.3.8
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
"use strict";var strShimFunction="function",strShimObject="object",strShimUndefined="undefined",strShimPrototype="prototype",ObjClass$1=Object,ObjProto$1=ObjClass$1[strShimPrototype];function _pureAssign(e,t){return e||t}function _pureRef(e,t){return e[t]}var UNDEF_VALUE=undefined,NULL_VALUE=null,EMPTY="",FUNCTION="function",OBJECT="object",PROTOTYPE="prototype",__PROTO__="__proto__",UNDEFINED="undefined",CONSTRUCTOR="constructor",SYMBOL="Symbol",LENGTH="length",NAME="name",CALL="call",TO_STRING="toString",GET_OWN_PROPERTY_DESCRIPTOR="getOwnPropertyDescriptor",ObjClass=_pureAssign(Object),ObjProto=_pureRef(ObjClass,PROTOTYPE),StrCls=_pureAssign(String),StrProto=_pureRef(StrCls,PROTOTYPE),MathCls=_pureAssign(Math),ArrCls=_pureAssign(Array),ArrProto=_pureRef(ArrCls,PROTOTYPE),ArrSlice=_pureRef(ArrProto,"slice"),POLYFILL_TAG="_polyfill",POLYFILL_TYPE_NAME="__nw21$polytype__";function safe(e,t){try{return{v:e.apply(this,t)}}catch(n){return{e:n}}}function safeGet(e,t,n){e=safe(e,n);return e.e?t:e.v}function _createIs(t){return function(e){return typeof e===t}}function _createObjIs(e){var t="[object "+e+"]";return function(e){return!(!e||objToString(e)!==t)}}function objToString(e){return ObjProto[TO_STRING].call(e)}function isUndefined(e){return typeof e===UNDEFINED||e===UNDEFINED}function isStrictUndefined(e){return e===UNDEF_VALUE}function isNullOrUndefined(e){return e===NULL_VALUE||isUndefined(e)}function isStrictNullOrUndefined(e){return e===NULL_VALUE||e===UNDEF_VALUE}function isDefined(e){return!!e||e!==UNDEF_VALUE}var isString=_createIs("string"),isFunction=_createIs(FUNCTION);function isObject(e){return!(!e&&isNullOrUndefined(e)||!e||typeof e!==OBJECT)}var isArray=_pureRef(ArrCls,"isArray"),isBoolean=_createIs("boolean"),isError=_createObjIs("Error");function isTruthy(e){return!(!e||safeGet(function(){return!(e&&0+e)},!e))}function _returnNothing(){}function _returnFalse(){return!1}var asString=_pureAssign(StrCls),ERROR_TYPE="[object Error]";function dumpObj(e,t){var n=EMPTY,r=ObjProto[TO_STRING][CALL](e);r===ERROR_TYPE&&(e={stack:asString(e.stack),message:asString(e.message),name:asString(e.name)});try{n=((n=JSON.stringify(e,NULL_VALUE,t?"number"==typeof t?t:4:UNDEF_VALUE))?n.replace(/"(\w+)"\s*:\s{0,1}/g,"$1: "):NULL_VALUE)||asString(e)}catch(o){n=" - "+dumpObj(o,t)}return r+": "+n}function throwError(e){throw Error(e)}function throwTypeError(e){throw new TypeError(e)}function _throwIfNullOrUndefined(e){isStrictNullOrUndefined(e)&&throwTypeError("Cannot convert undefined or null to object")}function _throwIfNotString(e){isString(e)||throwTypeError("'"+dumpObj(e)+"' is not a string")}function objHasOwnProperty(e,t){return!!e&&ObjProto.hasOwnProperty[CALL](e,t)}var _objGetOwnPropertyDescriptor$2=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),objHasOwn=_pureAssign(_pureRef(ObjClass,"hasOwn"),polyObjHasOwn);function polyObjHasOwn(e,t){return _throwIfNullOrUndefined(e),objHasOwnProperty(e,t)||!!_objGetOwnPropertyDescriptor$2(e,t)}function objForEachKey(e,t,n){if(e&&(isObject(e)||isFunction(e)))for(var r in e)if(objHasOwn(e,r)&&-1===t[CALL](n||e,r,e[r]))break}function arrForEach(e,t,n){if(e)for(var r=e[LENGTH]>>>0,o=0;o<r&&!(o in e&&-1===t[CALL](n||e,e[o],o,e));o++);}var _unwrapFunction=_unwrapFunctionWithPoly;function _unwrapFunctionWithPoly(r,e,o){var a=e?e[r]:NULL_VALUE;return function(e){var t,n=(e?e[r]:NULL_VALUE)||a;if(n||o)return t=arguments,(n||o).apply(e,n?ArrSlice[CALL](t,1):t);throwTypeError('"'+asString(r)+'" not defined for '+dumpObj(e))}}var _objGetOwnPropertyDescriptor$1=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),propMap={e:"enumerable",c:"configurable",v:"value",w:"writable",g:"get",s:"set"};function _createProp(t){var e,n={};return n[propMap.c]=!0,n[propMap.e]=!0,t.l&&(n.get=function(){return t.l.v},(e=_objGetOwnPropertyDescriptor$1(t.l,"v"))&&e.set&&(n.set=function(e){t.l.v=e})),objForEachKey(t,function(e,t){n[propMap[e]]=isStrictUndefined(t)?n[propMap[e]]:t}),n}var objDefineProp=_pureRef(ObjClass,"defineProperty"),objDefineProperties=_pureRef(ObjClass,"defineProperties");function objDefine(e,t,n){return objDefineProp(e,t,_createProp(n))}function _createKeyValueMap(e,n,r,t,o){var a={};return objForEachKey(e,function(e,t){_assignMapValue(a,e,n?t:e),_assignMapValue(a,t,r?t:e)}),t?t(a):a}function _assignMapValue(e,t,n,r){objDefineProp(e,t,{value:n,enumerable:!0,writable:!1})}var objIsFrozen=_pureAssign(_pureRef(ObjClass,"isFrozen"),_returnFalse),_objFreeze=_pureRef(ObjClass,"freeze");function _doNothing(e){return e}function _getProto(e){return _throwIfNullOrUndefined(e),e[__PROTO__]||NULL_VALUE}var objAssign=_pureRef(ObjClass,"assign"),objKeys=_pureRef(ObjClass,"keys");function _deepFreeze(e,n){if((isArray(e)||isObject(e)||isFunction(e))&&!objIsFrozen(e)){for(var t=0;t<n.length;t++)if(n[t]===e)return e;n.push(e),objForEachKey(e,function(e,t){_deepFreeze(t,n)}),objFreeze(e)}return e}function objDeepFreeze(e){return _objFreeze?_deepFreeze(e,[]):e}var objFreeze=_pureAssign(_objFreeze,_doNothing),objGetPrototypeOf=_pureAssign(_pureRef(ObjClass,"getPrototypeOf"),_getProto);function createEnum(e){return _createKeyValueMap(e,1,0,objFreeze)}function createEnumKeyMap(e){return _createKeyValueMap(e,0,0,objFreeze)}var _globalCfg,_wellKnownSymbolMap=createEnumKeyMap({asyncIterator:0,hasInstance:1,isConcatSpreadable:2,iterator:3,match:4,matchAll:5,replace:6,search:7,species:8,split:9,toPrimitive:10,toStringTag:11,unscopables:12}),GLOBAL_CONFIG_KEY="__tsUtils$gblCfg";function _getGlobalValue(){var e;return(e=(e=(e=typeof globalThis!==UNDEFINED?globalThis:e)||typeof self===UNDEFINED?e:self)||typeof window===UNDEFINED?e:window)||typeof global===UNDEFINED?e:global}function _getGlobalConfig(){var e;return _globalCfg||(e=safe(_getGlobalValue).v||{},_globalCfg=e[GLOBAL_CONFIG_KEY]=e[GLOBAL_CONFIG_KEY]||{}),_globalCfg}var mathMax=_pureRef(MathCls,"max"),strSlice=_unwrapFunctionWithPoly("slice",StrProto),strSubstring=_unwrapFunctionWithPoly("substring",StrProto),strSubstr=_unwrapFunctionWithPoly("substr",StrProto,polyStrSubstr);function polyStrSubstr(e,t,n){return _throwIfNullOrUndefined(e),n<0?EMPTY:((t=t||0)<0&&(t=mathMax(t+e[LENGTH],0)),isUndefined(n)?strSlice(e,t):strSlice(e,t,t+n))}function strLeft(e,t){return strSubstring(e,0,t)}function _tagAsPolyfill(e,t){return e&&(safe(function(){e[POLYFILL_TAG]=!0,e[POLYFILL_TYPE_NAME]=t}),safe(objDefine,[e,POLYFILL_TAG,{v:!0,w:!1,e:!1}]),safe(objDefine,[e,POLYFILL_TYPE_NAME,{v:t,w:!1,e:!1}])),e}var _globalLazyTestHooks,objCreate=_pureAssign(_pureRef(ObjClass,"create"),polyObjCreate);function polyObjCreate(e,t){var n;function r(){}return n=isStrictNullOrUndefined(e)?{}:((n=typeof e)!==OBJECT&&n!==FUNCTION&&throwTypeError("Prototype must be an Object or function: "+dumpObj(e)),r[PROTOTYPE]=e,safe(function(){r[__PROTO__]=e}),new r),t&&safe(objDefineProperties,[n,t]),n}function utcNow(){return(Date.now||polyUtcNow)()}function polyUtcNow(){return(new Date).getTime()}function fnApply(e,t,n){return e.apply(t,n)}function _initTestHooks(){_globalLazyTestHooks=_getGlobalConfig()}function getLazy(t,n){var r={};return _globalLazyTestHooks||_initTestHooks(),r.b=_globalLazyTestHooks.lzy,objDefineProp(r,"v",{configurable:!0,get:function(){var e=fnApply(t,null,n);return _globalLazyTestHooks.lzy||objDefineProp(r,"v",{value:e}),r.b=_globalLazyTestHooks.lzy,e}}),r}var _polySymbols,_wellKnownSymbolCache,mathRandom=_pureRef(MathCls,"random"),_uniqueInstanceId=getLazy(function(){for(var e=utcNow().toString(36).slice(2);e.length<16;)e+=mathRandom().toString(36).slice(2);return e.substring(0,16)}),UNIQUE_REGISTRY_ID="_urid",POLY_SYM="$nw21sym",_polyId=0;function _globalSymbolRegistry(){var e;return _polySymbols||(e=_getGlobalConfig(),_polySymbols=e.gblSym=e.gblSym||{k:{},s:{}}),_polySymbols}function polyNewSymbol(e){var t="_"+_polyId+++"_"+_uniqueInstanceId.v,n=SYMBOL+"("+e+")";function r(e,t){objDefine(o,e,{v:t,e:!1,w:!1})}var o=objCreate(null);return r("description",asString(e)),r(TO_STRING,function(){return n+POLY_SYM+t}),r("valueOf",function(){return o}),r("v",n),r("_uid",t),_tagAsPolyfill(o,"symbol")}function polySymbolFor(e){var t,n,r=_globalSymbolRegistry();return objHasOwn(r.k,e)||(t=polyNewSymbol(e),n=objKeys(r.s).length,t[UNIQUE_REGISTRY_ID]=function(){return n+"_"+t[TO_STRING]()},r.k[e]=t,r.s[t[UNIQUE_REGISTRY_ID]()]=asString(e)),r.k[e]}function polyGetKnownSymbol(e){_wellKnownSymbolCache=_wellKnownSymbolCache||{};e=_wellKnownSymbolMap[e];return e?_wellKnownSymbolCache[e]=_wellKnownSymbolCache[e]||polyNewSymbol(SYMBOL+"."+e):void 0}function createCachedValue(e){return objDefineProp({toJSON:function(){return e}},"v",{value:e})}var _cachedGlobal,WINDOW="window";function _getGlobalInstFn(e,t){var n;return function(){return _globalLazyTestHooks||_initTestHooks(),(n=n&&!_globalLazyTestHooks.lzy?n:createCachedValue(safe(e,t).v)).v}}function getGlobal(e){return _globalLazyTestHooks||_initTestHooks(),(_cachedGlobal=_cachedGlobal&&!1!==e&&!_globalLazyTestHooks.lzy?_cachedGlobal:createCachedValue(safe(_getGlobalValue).v||NULL_VALUE)).v}function getInst(e,t){t=_cachedGlobal&&!1!==t?_cachedGlobal.v:getGlobal(t);if(t&&t[e])return t[e];if(e===WINDOW)try{return window}catch(n){}return NULL_VALUE}var getDocument=_getGlobalInstFn(getInst,["document"]);function hasWindow(){return!!getWindow()}var getWindow=_getGlobalInstFn(getInst,[WINDOW]),getNavigator=_getGlobalInstFn(getInst,["navigator"]);function hasHistory(){return!!getHistory()}var _symbol,_symbolFor,_iterSymbol$1,getHistory=_getGlobalInstFn(getInst,["history"]),isWebWorker=_getGlobalInstFn(function(){return!!safe(function(){return self&&self instanceof WorkerGlobalScope}).v});function _initSymbol(){return _symbol=createCachedValue(safe(getInst,[SYMBOL]).v)}function _getSymbolKey(e){var t=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return t.v?t.v[e]:UNDEF_VALUE}function getKnownSymbol(e,t){var n=_wellKnownSymbolMap[e],r=(_globalLazyTestHooks||_initTestHooks(),(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol());return r.v?r.v[n||e]:t?UNDEF_VALUE:polyGetKnownSymbol(e)}function newSymbol(e,t){_globalLazyTestHooks||_initTestHooks();var n=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return n.v?n.v(e):t?NULL_VALUE:polyNewSymbol(e)}function symbolFor(e){return _globalLazyTestHooks||_initTestHooks(),((_symbolFor=(_globalLazyTestHooks.lzy?0:_symbolFor)||createCachedValue(safe(_getSymbolKey,["for"]).v)).v||polySymbolFor)(e)}function isIterator(e){return!!e&&isFunction(e.next)}function isIterable(e){return!isStrictNullOrUndefined(e)&&isFunction(e[getKnownSymbol(3)])}function iterForOf(e,t,n){if(e&&(isIterator(e)||(e=e[(_iterSymbol$1=_iterSymbol$1||createCachedValue(getKnownSymbol(3))).v]?e[_iterSymbol$1.v]():NULL_VALUE),isIterator(e))){var r=UNDEF_VALUE,o=UNDEF_VALUE;try{for(var a=0;!(o=e.next()).done&&-1!==t[CALL](n||e,o.value,a,e);)a++}catch(i){r={e:i},e["throw"]&&(o=NULL_VALUE,e["throw"](r))}finally{try{o&&!o.done&&e["return"]&&e["return"](o)}finally{if(r)throw r.e}}}}function arrAppend(t,e){return!isUndefined(e)&&t&&(isArray(e)?fnApply(t.push,t,e):isIterator(e)||isIterable(e)?iterForOf(e,function(e){t.push(e)}):t.push(e)),t}var _isProtoArray,arrIndexOf=_unwrapFunctionWithPoly("indexOf",ArrProto),arrMap=_unwrapFunctionWithPoly("map",ArrProto),objSetPrototypeOf=_pureAssign(_pureRef(ObjClass,"setPrototypeOf"),_polyObjSetPrototypeOf);function _polyObjSetPrototypeOf(n,e){var t;return(_isProtoArray=_isProtoArray||createCachedValue(((t={})[__PROTO__]=[],t instanceof Array))).v?n[__PROTO__]=e:objForEachKey(e,function(e,t){return n[e]=t}),n}function _createCustomError(e,t,n){function r(){this[CONSTRUCTOR]=t,safe(objDefine,[this,NAME,{v:e,c:!0,e:!1}])}return safe(objDefine,[t,NAME,{v:e,c:!0,e:!1}]),(t=objSetPrototypeOf(t,n))[PROTOTYPE]=n===NULL_VALUE?objCreate(n):(r[PROTOTYPE]=n[PROTOTYPE],new r),t}function _setName(e,t){t&&(e[NAME]=t)}function createCustomError(o,a,e){var i=e||Error,_=i[PROTOTYPE][NAME],s=Error.captureStackTrace;return _createCustomError(o,function(){var e=this,t=arguments;try{safe(_setName,[i,o]);var n,r=fnApply(i,e,ArrSlice[CALL](t))||e;return r!==e&&(n=objGetPrototypeOf(e))!==objGetPrototypeOf(r)&&objSetPrototypeOf(r,n),s&&s(r,e[CONSTRUCTOR]),a&&a(r,t),r}finally{safe(_setName,[i,_])}},i)}function _createTrimFn(t){return function(e){return _throwIfNullOrUndefined(e),e&&e.replace?e.replace(t,EMPTY):e}}var _fnToString,_objCtrFnString,_gblWindow,_perf,polyStrTrim=_createTrimFn(/^\s+|(?=\s)\s+$/g),strTrim=_unwrapFunctionWithPoly("trim",StrProto,polyStrTrim),mathFloor=_pureRef(MathCls,"floor");function isPlainObject(e){if(!e||typeof e!==OBJECT)return!1;var t=!1;if(e!==(_gblWindow=_gblWindow||!hasWindow()||getWindow())){_objCtrFnString||(_fnToString=Function[PROTOTYPE][TO_STRING],_objCtrFnString=_fnToString[CALL](ObjClass));try{var n=objGetPrototypeOf(e),t=(t=!n)||!(!(n=objHasOwnProperty(n,CONSTRUCTOR)?n[CONSTRUCTOR]:n)||typeof n!==FUNCTION||_fnToString[CALL](n)!==_objCtrFnString)}catch(r){}}return t}function getPerformance(){return _globalLazyTestHooks||_initTestHooks(),(_perf=_perf&&!_globalLazyTestHooks.lzy?_perf:createCachedValue(safe(getInst,["performance"]).v)).v}var mathRound=_pureRef(MathCls,"round"),objGetOwnPropertyDescriptor=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),strEndsWith=_unwrapFunctionWithPoly("endsWith",StrProto,polyStrEndsWith);function polyStrEndsWith(e,t,n){_throwIfNotString(e);t=isString(t)?t:asString(t),n=!isUndefined(n)&&n<e[LENGTH]?n:e[LENGTH];return strSubstring(e,n-t[LENGTH],n)===t}var _setTimeoutFn,_clearTimeoutFn,strIndexOf=_unwrapFunctionWithPoly("indexOf",StrProto),REF="ref",UNREF="unref",HAS_REF="hasRef",ENABLED="enabled";function _createTimerHandler(e,t,n){var r,o=!0,a=e?t(NULL_VALUE):NULL_VALUE;function i(){return o=!1,a&&a[UNREF]&&a[UNREF](),r}function _(){a&&n(a),a=NULL_VALUE}function s(){return a=t(a),o||i(),r}return(r={cancel:_,refresh:s})[HAS_REF]=function(){return a&&a[HAS_REF]?a[HAS_REF]():o},r[REF]=function(){return o=!0,a&&a[REF]&&a[REF](),r},r[UNREF]=i,{h:r=objDefineProp(r,ENABLED,{get:function(){return!!a},set:function(e){!e&&a&&_(),e&&!a&&s()}}),dn:function(){a=NULL_VALUE}}}function _resolveTimeoutFn(e){var t,e=isFunction(e)?e:_setTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&0<t.length&&isFunction(t[0])&&(e=t[0])),e||setTimeout}function _resolveClearTimeoutFn(e){var t,e=isFunction(e)?e:_clearTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&1<t.length&&isFunction(t[1])&&(e=t[1])),e||clearTimeout}function _createTimeoutWith(e,t,n){var r=isArray(t),o=r?t.length:0,a=_resolveTimeoutFn(0<o?t[0]:r?UNDEF_VALUE:t),i=_resolveClearTimeoutFn(1<o?t[1]:UNDEF_VALUE),_=n[0],s=(n[0]=function(){s.dn(),fnApply(_,UNDEF_VALUE,ArrSlice[CALL](arguments))},_createTimerHandler(e,function(e){if(e){if(e.refresh)return e.refresh(),e;fnApply(i,UNDEF_VALUE,[e])}return fnApply(a,UNDEF_VALUE,n)},function(e){fnApply(i,UNDEF_VALUE,[e])}));return s.h}function scheduleTimeout(e,t){return _createTimeoutWith(!0,UNDEF_VALUE,ArrSlice[CALL](arguments))}(getGlobal()||{}).Symbol,(getGlobal()||{}).Reflect;var _a$4,strHasOwnProperty="hasOwnProperty",__objAssignFnImpl=function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])ObjProto$1[strHasOwnProperty].call(t,o)&&(e[o]=t[o]);return e},__assignFn=objAssign||__objAssignFnImpl,extendStaticsFn=function(e,t){return(extendStaticsFn=ObjClass$1.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t[strHasOwnProperty](n)&&(e[n]=t[n])})(e,t)};function __extendsFn(e,t){function n(){this.constructor=e}typeof t!==strShimFunction&&null!==t&&throwTypeError("Class extends value "+t+" is not a constructor or null"),extendStaticsFn(e,t),e[strShimPrototype]=null===t?objCreate(t):(n[strShimPrototype]=t[strShimPrototype],new n)}var Constructor="constructor",Prototype="prototype",strFunction="function",DynInstFuncTable="_dynInstFuncs",DynProxyTag="_isDynProxy",DynClassName="_dynClass",DynClassNamePrefix="_dynCls$",DynInstChkTag="_dynInstChk",DynAllowInstChkTag=DynInstChkTag,DynProtoDefaultOptions="_dfOpts",UnknownValue="_unknown_",str__Proto="__proto__",DynProtoBaseProto="_dyn"+str__Proto,DynProtoGlobalSettings="__dynProto$Gbl",DynProtoCurrent="_dynInstProto",strUseBaseInst="useBaseInst",strSetInstFuncs="setInstFuncs",Obj=Object,_objGetPrototypeOf=Obj.getPrototypeOf,_objGetOwnProps=Obj.getOwnPropertyNames,_gbl=getGlobal(),_gblInst=_gbl[DynProtoGlobalSettings]||(_gbl[DynProtoGlobalSettings]={o:((_a$4={})[strSetInstFuncs]=!0,_a$4[strUseBaseInst]=!0,_a$4),n:1e3});function _isObjectOrArrayPrototype(e){return e&&(e===Obj[Prototype]||e===Array[Prototype])}function _isObjectArrayOrFunctionPrototype(e){return _isObjectOrArrayPrototype(e)||e===Function[Prototype]}function _getObjProto$1(e){if(e){if(_objGetPrototypeOf)return _objGetPrototypeOf(e);var t=e[str__Proto]||e[Prototype]||(e[Constructor]?e[Constructor][Prototype]:null),n=e[DynProtoBaseProto]||t;objHasOwnProperty(e,DynProtoBaseProto)||(delete e[DynProtoCurrent],n=e[DynProtoBaseProto]=e[DynProtoCurrent]||e[DynProtoBaseProto],e[DynProtoCurrent]=t)}return n}function _forEachProp(e,t){var n=[];if(_objGetOwnProps)n=_objGetOwnProps(e);else for(var r in e)"string"==typeof r&&objHasOwnProperty(e,r)&&n.push(r);if(n&&0<n.length)for(var o=0;o<n.length;o++)t(n[o])}function _isDynamicCandidate(e,t,n){return t!==Constructor&&typeof e[t]===strFunction&&(n||objHasOwnProperty(e,t))&&t!==str__Proto&&t!==Prototype}function _throwTypeError(e){throwTypeError("DynamicProto: "+e)}function _getInstanceFuncs(t){var n=objCreate(null);return _forEachProp(t,function(e){!n[e]&&_isDynamicCandidate(t,e,!1)&&(n[e]=t[e])}),n}function _hasVisited(e,t){for(var n=e.length-1;0<=n;n--)if(e[n]===t)return!0;return!1}function _getBaseFuncs(e,t,n,a){function r(e,t,n){var r,o=t[n];return o[DynProxyTag]&&a&&!1!==(r=e[DynInstFuncTable]||{})[DynAllowInstChkTag]&&(o=(r[t[DynClassName]]||{})[n]||o),function(){return o.apply(e,arguments)}}for(var o=objCreate(null),i=(_forEachProp(n,function(e){o[e]=r(t,n,e)}),_getObjProto$1(e)),_=[];i&&!_isObjectArrayOrFunctionPrototype(i)&&!_hasVisited(_,i);)_forEachProp(i,function(e){!o[e]&&_isDynamicCandidate(i,e,!_objGetPrototypeOf)&&(o[e]=r(t,i,e))}),_.push(i),i=_getObjProto$1(i);return o}function _getInstFunc(e,t,n,r){var o=null;if(e&&objHasOwnProperty(n,DynClassName)){var a=e[DynInstFuncTable]||objCreate(null);if((o=(a[n[DynClassName]]||objCreate(null))[t])||_throwTypeError("Missing ["+t+"] "+strFunction),!o[DynInstChkTag]&&!1!==a[DynAllowInstChkTag]){for(var i=!objHasOwnProperty(e,t),_=_getObjProto$1(e),s=[];i&&_&&!_isObjectArrayOrFunctionPrototype(_)&&!_hasVisited(s,_);){var c=_[t];if(c){i=c===r;break}s.push(_),_=_getObjProto$1(_)}try{i&&(e[t]=o),o[DynInstChkTag]=1}catch(u){a[DynAllowInstChkTag]=!1}}}return o}function _getProtoFunc(e,t,n){var r=t[e];return typeof(r=r===n?_getObjProto$1(t)[e]:r)!==strFunction&&_throwTypeError("["+e+"] is not a "+strFunction),r}function _populatePrototype(o,e,a,i,t){var n,_;_isObjectOrArrayPrototype(o)||_isObjectOrArrayPrototype(n=a[DynInstFuncTable]=a[DynInstFuncTable]||objCreate(null))||(_=n[e]=n[e]||objCreate(null),!1!==n[DynAllowInstChkTag]&&(n[DynAllowInstChkTag]=!!t),_isObjectOrArrayPrototype(_)||_forEachProp(a,function(e){var t,n,r;_isDynamicCandidate(a,e,!1)&&a[e]!==i[e]&&(_[e]=a[e],delete a[e],objHasOwnProperty(o,e)&&(!o[e]||o[e][DynProxyTag])||(o[e]=(t=o,n=e,(r=function(){return(_getInstFunc(this,n,t,r)||_getProtoFunc(n,t,r)).apply(this,arguments)})[DynProxyTag]=1,r)))}))}function _checkPrototype(e,t){if(_objGetPrototypeOf){for(var n=[],r=_getObjProto$1(t);r&&!_isObjectArrayOrFunctionPrototype(r)&&!_hasVisited(n,r);){if(r===e)return!0;n.push(r),r=_getObjProto$1(r)}return!1}return!0}function _getObjName(e,t){return objHasOwnProperty(e,Prototype)?e.name||t||UnknownValue:((e||{})[Constructor]||{}).name||t||UnknownValue}function dynamicProto(e,t,n,r){objHasOwnProperty(e,Prototype)||_throwTypeError("theClass is an invalid class definition.");var o=e[Prototype],a=(_checkPrototype(o,t)||_throwTypeError("["+_getObjName(e)+"] not in hierarchy of ["+_getObjName(t)+"]"),null),e=(objHasOwnProperty(o,DynClassName)?a=o[DynClassName]:(a=DynClassNamePrefix+_getObjName(e,"_")+"$"+_gblInst.n,_gblInst.n++,o[DynClassName]=a),dynamicProto[DynProtoDefaultOptions]),i=!!e[strUseBaseInst],_=(i&&r&&r[strUseBaseInst]!==undefined&&(i=!!r[strUseBaseInst]),_getInstanceFuncs(t)),i=(n(t,_getBaseFuncs(o,t,_,i)),!!_objGetPrototypeOf&&!!e[strSetInstFuncs]);_populatePrototype(o,a,t,_,!1!==(i=i&&r?!!r[strSetInstFuncs]:i))}dynamicProto[DynProtoDefaultOptions]=_gblInst.o;var aggregationErrorType,createEnumStyle=createEnum,_DYN_TO_LOWER_CASE$1="toLowerCase",_DYN_LENGTH$2="length",_DYN_WARN_TO_CONSOLE="warnToConsole",_DYN_THROW_INTERNAL="throwInternal",_DYN_WATCH="watch",_DYN_APPLY="apply",_DYN_PUSH="push",_DYN_SPLICE="splice",_DYN_LOGGER="logger",_DYN_CANCEL="cancel",_DYN_INITIALIZE="initialize",_DYN_IDENTIFIER="identifier",_DYN_IS_INITIALIZED="isInitialized",_DYN_GET_PLUGIN="getPlugin",_DYN_NAME$1="name",_DYN_PROCESS_NEXT="processNext",_DYN_GET_PROCESS_TEL_CONT2="getProcessTelContext",_DYN_ENABLED="enabled",_DYN_UNLOAD="unload",_DYN_LOGGING_LEVEL_CONSOL4="loggingLevelConsole",_DYN_CREATE_NEW="createNew",_DYN_TEARDOWN="teardown",_DYN_MESSAGE_ID="messageId",_DYN_MESSAGE$1="message",_DYN_DIAG_LOG$1="diagLog",_DYN__DO_TEARDOWN="_doTeardown",_DYN_UPDATE="update",_DYN_GET_NEXT="getNext",_DYN_SET_NEXT_PLUGIN="setNextPlugin",_DYN_USER_AGENT="userAgent",_DYN_SPLIT$1="split",_DYN_REPLACE="replace",_DYN_TYPE="type",_DYN_EVT_NAME="evtName",_DYN_IS_CHILD_EVT="isChildEvt",_DYN_GET_CTX="getCtx",_DYN_SET_CTX="setCtx",_DYN_GET_ATTRIBUTE="getAttribute";function throwAggregationError(e,t){aggregationErrorType=aggregationErrorType||createCustomError("AggregationError",function(e,t){1<t[_DYN_LENGTH$2]&&(e.errors=t[1])});var n=e||"One or more errors occurred.";throw arrForEach(t,function(e,t){n+="\n".concat(t," > ").concat(dumpObj(e))}),new aggregationErrorType(n,t||[])}var UNDEFINED_VALUE=undefined,STR_EMPTY="",STR_CORE="core",STR_DISABLED="disabled",STR_EXTENSION_CONFIG="extensionConfig",STR_PROCESS_TELEMETRY="processTelemetry",STR_PRIORITY="priority",STR_GET_PERF_MGR="getPerfMgr",STR_DOMAIN="domain",STR_PATH="path",STR_NOT_DYNAMIC_ERROR="Not dynamic - ",strGetPrototypeOf="getPrototypeOf",rCamelCase=/-([a-z])/g,rNormalizeInvalid=/([^\w\d_$])/g,rLeadingNumeric=/^(\d+[\w\d_$])/,_getObjProto=Object[strGetPrototypeOf];function isNotNullOrUndefined(e){return!isNullOrUndefined(e)}function normalizeJsName(e){return e&&isString(e)?(e=(e=e[_DYN_REPLACE](rCamelCase,function(e,t){return t.toUpperCase()}))[_DYN_REPLACE](rNormalizeInvalid,"_"))[_DYN_REPLACE](rLeadingNumeric,function(e,t){return"_"+t}):e}function strContains(e,t){return!(!e||!t)&&-1!==strIndexOf(e,t)}function toISOString(e){return e&&e.toISOString()||""}function getExceptionName(e){return isError(e)?e[_DYN_NAME$1]:STR_EMPTY}function setValue(e,t,n,r,o){var a=n;return!e||(a=e[t])===n||o&&!o(a)||r&&!r(n)||(e[t]=a=n),a}function _createProxyFunction(e,t){var n=null,r=null;return isFunction(e)?n=e:r=e,function(){var e=arguments;if(r=n?n():r)return r[t][_DYN_APPLY](r,e)}}function proxyFunctionAs(e,t,n,r,o){e&&t&&n&&(!1===o&&!isUndefined(e[t])||(e[t]=_createProxyFunction(n,r)))}var strLocation="location",strConsole="console",strJSON="JSON",strCrypto="crypto",strMsCrypto="msCrypto",strMsie="msie",strTrident="trident/",_isTrident=null,_navUserAgentCheck=null,_enableMocks=!1;function getLocation(e){if(e&&_enableMocks){e=getInst("__mockLocation");if(e)return e}return typeof location===strShimObject&&location?location:getInst(strLocation)}function getConsole(){return typeof console!==strShimUndefined?console:getInst(strConsole)}function hasJSON(){return!!(typeof JSON===strShimObject&&JSON||null!==getInst(strJSON))}function getJSON(){return hasJSON()?JSON||getInst(strJSON):null}function getCrypto(){return getInst(strCrypto)}function getMsCrypto(){return getInst(strMsCrypto)}function isIE(){var e=getNavigator();return!e||e[_DYN_USER_AGENT]===_navUserAgentCheck&&null!==_isTrident||(e=((_navUserAgentCheck=e[_DYN_USER_AGENT])||STR_EMPTY)[_DYN_TO_LOWER_CASE$1](),_isTrident=strContains(e,strMsie)||strContains(e,strTrident)),_isTrident}var UInt32Mask=4294967296,MaxUInt32=4294967295,SEED1=123456789,SEED2=987654321,_mwcSeeded=!1,_mwcW=SEED1,_mwcZ=SEED2;function _mwcSeed(e){e<0&&(e>>>=0),_mwcW=SEED1+e&MaxUInt32,_mwcZ=SEED2-e&MaxUInt32,_mwcSeeded=!0}function _autoSeedMwc(){try{var e=2147483647&utcNow();_mwcSeed((Math.random()*UInt32Mask^e)+e)}catch(t){}}function random32(e){var t=0,n=getCrypto()||getMsCrypto();return 0===(t=n&&n.getRandomValues?n.getRandomValues(new Uint32Array(1))[0]&MaxUInt32:t)&&isIE()&&(_mwcSeeded||_autoSeedMwc(),t=mwcRandom32()&MaxUInt32),0===t&&(t=mathFloor(UInt32Mask*Math.random()|0)),e||(t>>>=0),t}function mwcRandom32(e){var t=((_mwcZ=36969*(65535&_mwcZ)+(_mwcZ>>16)&MaxUInt32)<<16)+(65535&(_mwcW=18e3*(65535&_mwcW)+(_mwcW>>16)&MaxUInt32))>>>0&MaxUInt32|0;return e||(t>>>=0),t}function newId(e){void 0===e&&(e=22);for(var t=random32()>>>0,n=0,r=STR_EMPTY;r[_DYN_LENGTH$2]<e;)r+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[0|63&t]||"",t>>>=6,5==++n&&(t=(random32()<<2&4294967295|3&t)>>>0,n=0);return r}var version="3.3.8",instanceName="."+newId(6),_dataUid=0;function _canAcceptData(e){return 1===e.nodeType||9===e.nodeType||!+e.nodeType}function _getCache(e,t){var n=t[e.id];if(!n){n={};try{_canAcceptData(t)&&objDefine(t,e.id,{e:!1,v:n})}catch(r){}}return n}function createUniqueNamespace(e,t){return normalizeJsName(e+_dataUid+++((t=void 0!==t&&t)?"."+version:STR_EMPTY)+instanceName)}function createElmNodeData(e){var a={id:createUniqueNamespace("_aiData-"+(e||STR_EMPTY)+"."+version),accept:function(e){return _canAcceptData(e)},get:function(e,t,n,r){var o=e[a.id];return o?o[normalizeJsName(t)]:(r&&((o=_getCache(a,e))[normalizeJsName(t)]=n),n)},kill:function(e,t){if(e&&e[t])try{delete e[t]}catch(n){}}};return a}function _isConfigDefaults(e){return e&&isObject(e)&&!isArray(e)&&(e.isVal||e.fb||objHasOwn(e,"v")||objHasOwn(e,"mrg")||objHasOwn(e,"ref")||e.set)}function _getDefault(e,t,n){var r,o=n.dfVal||isDefined;if(t&&n.fb){var a=n.fb;isArray(a)||(a=[a]);for(var i=0;i<a[_DYN_LENGTH$2];i++){var _=a[i],s=t[_];if(o(s)?r=s:e&&(o(s=e.cfg[_])&&(r=s),e.set(e.cfg,asString(_),s)),o(r))break}}return!o(r)&&o(n.v)?n.v:r}function _resolveDefaultValue(n,r,e){var o,t=e;return(t=e&&_isConfigDefaults(e)?_getDefault(n,r,e):t)&&(_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),isArray(t)?(o=[])[_DYN_LENGTH$2]=t[_DYN_LENGTH$2]:isPlainObject(t)&&(o={}),o&&(objForEachKey(t,function(e,t){t&&_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),o[e]=t}),t=o)),t}function _applyDefaultValue(n,e,t,r){var o,a,i,_,s,c,u=r,u=_isConfigDefaults(u)?(o=u.isVal,a=u.set,s=u.rdOnly,l=u.blkVal,i=u.mrg,!(_=u.ref)&&isUndefined(_)&&(_=!!i),_getDefault(n,e,u)):r,r=(l&&n.blkVal(e,t),!0),l=e[t];!l&&isNullOrUndefined(l)||(c=l,r=!1,o&&c!==u&&!o(c)&&(c=u,r=!0),a&&(r=(c=a(c,u,e))===u)),r?c=u&&_resolveDefaultValue(n,e,u):(isPlainObject(c)||isArray(u))&&i&&u&&(isPlainObject(u)||isArray(u))&&objForEachKey(u,function(e,t){_applyDefaultValue(n,c,e,t)}),n.set(e,t,c),_&&n.ref(e,t),s&&n.rdOnly(e,t)}var CFG_HANDLER_LINK=symbolFor("[[ai_dynCfg_1]]"),BLOCK_DYNAMIC=symbolFor("[[ai_blkDynCfg_1]]"),FORCE_DYNAMIC=symbolFor("[[ai_frcDynCfg_1]]");function _cfgDeepCopy(e){var n;return e&&(isArray(e)?(n=[])[_DYN_LENGTH$2]=e[_DYN_LENGTH$2]:isPlainObject(e)&&(n={}),n)?(objForEachKey(e,function(e,t){n[e]=_cfgDeepCopy(t)}),n):e}function getDynamicConfigHandler(e){if(e){var t=e[CFG_HANDLER_LINK]||e;if(t.cfg&&(t.cfg===e||t.cfg[CFG_HANDLER_LINK]===t))return t}return null}function blockDynamicConversion(e){if(e&&(isPlainObject(e)||isArray(e)))try{e[BLOCK_DYNAMIC]=!0}catch(t){}return e}function _canMakeDynamic(e,t,n){var r=!1;return!n||e[t.blkVal]||(r=n[FORCE_DYNAMIC])||n[BLOCK_DYNAMIC]?r:isPlainObject(n)||isArray(n)}function throwInvalidAccess(e){throwTypeError("InvalidAccess:"+e)}var arrayMethodsToPatch=["push","pop","shift","unshift","splice"],_throwDynamicError=function(e,t,n,r){e&&e[_DYN_THROW_INTERNAL](3,108,"".concat(n," [").concat(t,"] failed - ")+dumpObj(r))};function _patchArray(o,a,i){isArray(a)&&arrForEach(arrayMethodsToPatch,function(e){var r=a[e];a[e]=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n=r[_DYN_APPLY](this,e);return _makeDynamicObject(o,a,i,"Patching"),n}})}function _getOwnPropGetter(e,t){e=objGetOwnPropertyDescriptor(e,t);return e&&e.get}function _createDynamicProperty(o,a,i,_){var s={n:i,h:[],trk:function(e){e&&e.fn&&(-1===arrIndexOf(s.h,e)&&s.h[_DYN_PUSH](e),o.trk(e,s))},clr:function(e){e=arrIndexOf(s.h,e);-1!==e&&s.h[_DYN_SPLICE](e,1)}},c=!0,u=!1;function l(){c&&(u=u||_canMakeDynamic(l,o,_),_&&!_[CFG_HANDLER_LINK]&&u&&(_=_makeDynamicObject(o,_,i,"Converting")),c=!1);var e=o.act;return e&&s.trk(e),_}l[o.prop]={chng:function(){o.add(s)}},objDefine(a,s.n,{g:l,s:function(t){if(_!==t){l[o.ro]&&!o.upd&&throwInvalidAccess("["+i+"] is read-only:"+dumpObj(a)),c&&(u=u||_canMakeDynamic(l,o,_),c=!1);var e,n=u&&l[o.rf];if(u)if(n){objForEachKey(_,function(e){_[e]=t?t[e]:UNDEFINED_VALUE});try{objForEachKey(t,function(e,t){_setDynamicProperty(o,_,e,t)}),t=_}catch(r){_throwDynamicError((o.hdlr||{})[_DYN_LOGGER],i,"Assigning",r),u=!1}}else _&&_[CFG_HANDLER_LINK]&&objForEachKey(_,function(e){var e=_getOwnPropGetter(_,e);e&&(e=e[o.prop])&&e.chng()});t!==_&&(e=t&&_canMakeDynamic(l,o,t),!n&&e&&(t=_makeDynamicObject(o,t,i,"Converting")),_=t,u=e),o.add(s)}}})}function _setDynamicProperty(e,t,n,r){var o;return t&&((o=_getOwnPropGetter(t,n))&&o[e.prop]?t[n]=r:_createDynamicProperty(e,t,n,r)),t}function _setDynamicPropertyState(e,t,n,r){if(t){var o=_getOwnPropGetter(t,n),a=o&&!!o[e.prop],i=r&&r[0],_=r&&r[1],r=r&&r[2];if(!a){if(r)try{blockDynamicConversion(t)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"Blocking",s)}try{_setDynamicProperty(e,t,n,t[n]),o=_getOwnPropGetter(t,n)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"State",s)}}i&&(o[e.rf]=i),_&&(o[e.ro]=_),r&&(o[e.blkVal]=!0)}return t}function _makeDynamicObject(n,r,e,t){try{objForEachKey(r,function(e,t){_setDynamicProperty(n,r,e,t)}),r[CFG_HANDLER_LINK]||(objDefineProp(r,CFG_HANDLER_LINK,{get:function(){return n.hdlr}}),_patchArray(n,r,e))}catch(o){_throwDynamicError((n.hdlr||{})[_DYN_LOGGER],e,t,o)}return r}var symPrefix="[[ai_",symPostfix="]]";function _createState(a){var i,e=newSymbol(symPrefix+"get"+a.uid+symPostfix),t=newSymbol(symPrefix+"ro"+a.uid+symPostfix),n=newSymbol(symPrefix+"rf"+a.uid+symPostfix),r=newSymbol(symPrefix+"blkVal"+a.uid+symPostfix),_=newSymbol(symPrefix+"dtl"+a.uid+symPostfix),o=null,s=null;function c(t,e){var n=i.act;try{(i.act=t)&&t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=[]),e({cfg:a.cfg,set:a.set.bind(a),setDf:a.setDf.bind(a),ref:a.ref.bind(a),rdOnly:a.rdOnly.bind(a)})}catch(o){var r=a[_DYN_LOGGER];throw r&&r[_DYN_THROW_INTERNAL](1,107,dumpObj(o)),o}finally{i.act=n||null}}function u(){if(o){var e=o,n=(o=null,s&&s[_DYN_CANCEL](),s=null,[]);if(arrForEach(e,function(t){if(t&&(t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=null),t.fn))try{c(t,t.fn)}catch(e){n[_DYN_PUSH](e)}}),o)try{u()}catch(t){n[_DYN_PUSH](t)}0<n[_DYN_LENGTH$2]&&throwAggregationError("Watcher error(s): ",n)}}return i={prop:e,ro:t,rf:n,blkVal:r,hdlr:a,add:function(e){if(e&&0<e.h[_DYN_LENGTH$2]){o=o||[],s=s||scheduleTimeout(function(){s=null,u()},0);for(var t=0;t<e.h[_DYN_LENGTH$2];t++){var n=e.h[t];n&&-1===arrIndexOf(o,n)&&o[_DYN_PUSH](n)}}},notify:u,use:c,trk:function(e,t){e&&(e=e[_]=e[_]||[],-1===arrIndexOf(e,t)&&e[_DYN_PUSH](t))}}}function _createAndUseHandler(e,t){var n={fn:t,rm:function(){n.fn=null,t=e=null}};return objDefine(n,"toJSON",{v:function(){return"WatcherHandler"+(n.fn?"":"[X]")}}),e.use(n,t),n}function _createDynamicHandler(o,e,t){var n=getDynamicConfigHandler(e);if(n)return n;var a,n=createUniqueNamespace("dyncfg",!0),t=e&&!1!==t?e:_cfgDeepCopy(e),r={uid:null,cfg:t,logger:o,notify:function(){a.notify()},set:function(e,t,n){try{e=_setDynamicProperty(a,e,t,n)}catch(r){_throwDynamicError(o,t,"Setting value",r)}return e[t]},setDf:function(n,e){return e&&objForEachKey(e,function(e,t){_applyDefaultValue(r,n,e,t)}),n},watch:function(e){return _createAndUseHandler(a,e)},ref:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[0]=!0,e))[t]},rdOnly:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[1]=!0,e))[t]},blkVal:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[2]=!0,e))[t]},_block:function(n,r){a.use(null,function(e){var t=a.upd;try{isUndefined(r)||(a.upd=r),n(e)}finally{a.upd=t}})}};return objDefine(r,"uid",{c:!1,e:!1,w:!1,v:n}),_makeDynamicObject(a=_createState(r),t,"config","Creating"),r}function _logInvalidAccess(e,t){e?(e[_DYN_WARN_TO_CONSOLE](t),e[_DYN_THROW_INTERNAL](2,108,t)):throwInvalidAccess(t)}function createDynamicConfig(e,t,n,r){n=_createDynamicHandler(n,e||{},r);return t&&n.setDf(n.cfg,t),n}function onConfigChange(e,t,n){var r=e[CFG_HANDLER_LINK]||e;return!r.cfg||r.cfg!==e&&r.cfg[CFG_HANDLER_LINK]!==r?(_logInvalidAccess(n,STR_NOT_DYNAMIC_ERROR+dumpObj(e)),createDynamicConfig(e,null,n)[_DYN_WATCH](t)):r[_DYN_WATCH](t)}function _stringToBoolOrDefault(e,t,n){return!e&&isNullOrUndefined(e)?t:isBoolean(e)?e:"true"===asString(e)[_DYN_TO_LOWER_CASE$1]()}function cfgDfMerge(e){return{mrg:!0,v:e}}function cfgDfSet(e,t){return{set:e,v:t}}function cfgDfValidate(e,t,n){return{fb:n,isVal:e,v:t}}function cfgDfBoolean(e,t){return{fb:t,set:_stringToBoolOrDefault,v:!!e}}function cfgDfString(e){return{isVal:isString,v:asString(e||STR_EMPTY)}}var _a$3,_aiNamespace=null;function _getExtensionNamespace(){var e=getInst("Microsoft");return _aiNamespace=e?e.ApplicationInsights:_aiNamespace}function getDebugExt(e){var t=_aiNamespace;return(t=t||!0===e.disableDbgExt?t:_aiNamespace||_getExtensionNamespace())?t.ChromeDbgExt:null}var STR_WARN_TO_CONSOLE="warnToConsole",AiNonUserActionablePrefix="AI (Internal): ",AiUserActionablePrefix="AI: ",AIInternalMessagePrefix="AITR_",defaultValues$2={loggingLevelConsole:0,loggingLevelTelemetry:1,maxMessageLimit:25,enableDebug:!1},_logFuncs=((_a$3={})[0]=null,_a$3[1]="errorToConsole",_a$3[2]=STR_WARN_TO_CONSOLE,_a$3[3]="debugToConsole",_a$3);function _sanitizeDiagnosticText(e){return e?'"'+e[_DYN_REPLACE](/\"/g,STR_EMPTY)+'"':STR_EMPTY}function _logToConsole(e,t){var n,r=getConsole();r&&(n="log",r[e]&&(n=e),isFunction(r[n])&&r[n](t))}var _InternalLogMessage=function(){function e(e,t,n,r){void 0===n&&(n=!1),this[_DYN_MESSAGE_ID]=e,this[_DYN_MESSAGE$1]=(n?AiUserActionablePrefix:AiNonUserActionablePrefix)+e;n=STR_EMPTY,hasJSON()&&(n=getJSON().stringify(r)),e=(t?" message:"+_sanitizeDiagnosticText(t):STR_EMPTY)+(r?" props:"+_sanitizeDiagnosticText(n):STR_EMPTY);this[_DYN_MESSAGE$1]+=e}return e.dataType="MessageData",e}();function safeGetLogger(e,t){return(e||{})[_DYN_LOGGER]||new DiagnosticLogger(t)}var _a$2,_b,DiagnosticLogger=function(){function e(r){this.identifier="DiagnosticLogger",this.queue=[];var s,o,c,u,t,l=0,E={};dynamicProto(e,this,function(a){function i(e,t){var n,r;c<=l||(r=!0,n=AIInternalMessagePrefix+t[_DYN_MESSAGE_ID],E[n]?r=!1:E[n]=!0,r&&(e<=o&&(a.queue[_DYN_PUSH](t),l++,_(1===e?"error":"warn",t)),l===c&&(r=new _InternalLogMessage(23,n="Internal events throttle limit per PageView reached for this app.",!1),a.queue[_DYN_PUSH](r),1===e?a.errorToConsole(n):a[_DYN_WARN_TO_CONSOLE](n))))}function _(e,t){var n=getDebugExt(r||{});n&&n[_DYN_DIAG_LOG$1]&&n[_DYN_DIAG_LOG$1](e,t)}t=onConfigChange(createDynamicConfig(r||{},defaultValues$2,a).cfg,function(e){e=e.cfg;s=e[_DYN_LOGGING_LEVEL_CONSOL4],o=e.loggingLevelTelemetry,c=e.maxMessageLimit,u=e.enableDebug}),a.consoleLoggingLevel=function(){return s},a[_DYN_THROW_INTERNAL]=function(e,t,n,r,o){t=new _InternalLogMessage(t,n,o=void 0!==o&&o,r);if(u)throw dumpObj(t);n=_logFuncs[e]||STR_WARN_TO_CONSOLE;isUndefined(t[_DYN_MESSAGE$1])?_("throw"+(1===e?"Critical":"Warning"),t):(o?(r=+t[_DYN_MESSAGE_ID],!E[r]&&e<=s&&(a[n](t[_DYN_MESSAGE$1]),E[r]=!0)):e<=s&&a[n](t[_DYN_MESSAGE$1]),i(e,t))},a.debugToConsole=function(e){_logToConsole("debug",e),_("warning",e)},a[_DYN_WARN_TO_CONSOLE]=function(e){_logToConsole("warn",e),_("warning",e)},a.errorToConsole=function(e){_logToConsole("error",e),_("error",e)},a.resetInternalMessageCount=function(){l=0,E={}},a.logInternalMessage=i,a[_DYN_UNLOAD]=function(e){t&&t.rm(),t=null}})}return e.__ieDyn=1,e}();function _getLogger(e){return e||new DiagnosticLogger}function _throwInternal(e,t,n,r,o,a){void 0===a&&(a=!1),_getLogger(e)[_DYN_THROW_INTERNAL](t,n,r,o,a)}function _warnToConsole(e,t){_getLogger(e)[_DYN_WARN_TO_CONSOLE](t)}var _doc,strToGMTString="toGMTString",strToUTCString="toUTCString",strCookie="cookie",strExpires="expires",strIsCookieUseDisabled="isCookieUseDisabled",strDisableCookiesUsage="disableCookiesUsage",strConfigCookieMgr="_ckMgr",_supportsCookies=null,_allowUaSameSite=null,_parsedCookieValue=null,_cookieCache={},_globalCookieConfig={},rootDefaultConfig=((_a$2={cookieCfg:cfgDfMerge(((_b={})[STR_DOMAIN]={fb:"cookieDomain",dfVal:isNotNullOrUndefined},_b.path={fb:"cookiePath",dfVal:isNotNullOrUndefined},_b.enabled=UNDEFINED_VALUE,_b.ignoreCookies=UNDEFINED_VALUE,_b.blockedCookies=UNDEFINED_VALUE,_b)),cookieDomain:UNDEFINED_VALUE,cookiePath:UNDEFINED_VALUE})[strDisableCookiesUsage]=UNDEFINED_VALUE,_a$2);function _getDoc(){_doc=_doc||getLazy(function(){return getDocument()})}function _gblCookieMgr(e,t){var n=createCookieMgr[strConfigCookieMgr]||_globalCookieConfig[strConfigCookieMgr];return n||(n=createCookieMgr[strConfigCookieMgr]=createCookieMgr(e,t),_globalCookieConfig[strConfigCookieMgr]=n),n}function _isMgrEnabled(e){return!e||e.isEnabled()}function _isIgnoredCookie(e,t){return!!(t&&e&&isArray(e.ignoreCookies))&&-1!==arrIndexOf(e.ignoreCookies,t)}function _isBlockedCookie(e,t){return!!(t&&e&&isArray(e.blockedCookies)&&-1!==arrIndexOf(e.blockedCookies,t))||_isIgnoredCookie(e,t)}function _isCfgEnabled(e,t){var n,t=t[_DYN_ENABLED];return isNullOrUndefined(t)&&(n=void 0,isUndefined(e[strIsCookieUseDisabled])||(n=!e[strIsCookieUseDisabled]),t=n=isUndefined(e[strDisableCookiesUsage])?n:!e[strDisableCookiesUsage]),t}function safeGetCookieMgr(e,t){var n,r;return e?r=e.getCookieMgr():t&&(r=(n=t.cookieCfg)&&n[strConfigCookieMgr]?n[strConfigCookieMgr]:createCookieMgr(t)),r||_gblCookieMgr(t,(e||{})[_DYN_LOGGER])}function createCookieMgr(n,o){var c,u,l,r,a,E,i,t=onConfigChange(n=createDynamicConfig(n||_globalCookieConfig,null,o).cfg,function(e){e.setDf(e.cfg,rootDefaultConfig),c=e.ref(e.cfg,"cookieCfg"),u=c[STR_PATH]||"/",l=c[STR_DOMAIN],r=!1!==_isCfgEnabled(n,c),a=c.getCookie||_getCookieValue,E=c.setCookie||_setCookieValue,i=c.delCookie||_setCookieValue},o),N={isEnabled:function(){var e=!1!==_isCfgEnabled(n,c)&&r&&areCookiesSupported(o),t=_globalCookieConfig[strConfigCookieMgr];return e&&t&&N!==t?_isMgrEnabled(t):e},setEnabled:function(e){r=!1!==e,c[_DYN_ENABLED]=e},set:function(e,t,n,r,o){var a,i,_,s=!1;return _isMgrEnabled(N)&&!_isBlockedCookie(c,e)&&(a={},i=strTrim(t||STR_EMPTY),-1!==(_=strIndexOf(i,";"))&&(i=strTrim(strLeft(t,_)),a=_extractParts(strSubstring(t,_+1))),setValue(a,STR_DOMAIN,r||l,isTruthy,isUndefined),isNullOrUndefined(n)||(t=isIE(),isUndefined(a[strExpires])&&0<(_=utcNow()+1e3*n)&&((r=new Date).setTime(_),setValue(a,strExpires,_formatDate(r,t?strToGMTString:strToUTCString)||_formatDate(r,t?strToGMTString:strToUTCString)||STR_EMPTY,isTruthy)),t||setValue(a,"max-age",STR_EMPTY+n,null,isUndefined)),(_=getLocation())&&"https:"===_.protocol&&(setValue(a,"secure",null,null,isUndefined),(_allowUaSameSite=null===_allowUaSameSite?!uaDisallowsSameSiteNone((getNavigator()||{})[_DYN_USER_AGENT]):_allowUaSameSite)&&setValue(a,"SameSite","None",null,isUndefined)),setValue(a,STR_PATH,o||u,null,isUndefined),E(e,_formatCookieValue(i,a)),s=!0),s},get:function(e){var t=STR_EMPTY;return _isMgrEnabled(N)&&!_isIgnoredCookie(c,e)?a(e):t},del:function(e,t){return!!_isMgrEnabled(N)&&N.purge(e,t)},purge:function(e,t){var n,r=!1;return areCookiesSupported(o)&&((n={})[STR_PATH]=t||"/",n[strExpires]="Thu, 01 Jan 1970 00:00:01 GMT",t=n,isIE()||(t["max-age"]="0"),i(e,_formatCookieValue(STR_EMPTY,t)),r=!0),r},unload:function(e){t&&t.rm(),t=null}};return N[strConfigCookieMgr]=N}function areCookiesSupported(e){if(null===_supportsCookies){_supportsCookies=!1,_doc||_getDoc();try{var t=_doc.v||{};_supportsCookies=t[strCookie]!==undefined}catch(n){_throwInternal(e,2,68,"Cannot access document.cookie - "+getExceptionName(n),{exception:dumpObj(n)})}}return _supportsCookies}function _extractParts(e){var n={};return e&&e[_DYN_LENGTH$2]&&arrForEach(strTrim(e)[_DYN_SPLIT$1](";"),function(e){var t;(e=strTrim(e||STR_EMPTY))&&(-1===(t=strIndexOf(e,"="))?n[e]=null:n[strTrim(strLeft(e,t))]=strTrim(strSubstring(e,t+1)))}),n}function _formatDate(e,t){return isFunction(e[t])?e[t]():null}function _formatCookieValue(e,t){var n=e||STR_EMPTY;return objForEachKey(t,function(e,t){n+="; "+e+(isNullOrUndefined(t)?STR_EMPTY:"="+t)}),n}function _getCookieValue(e){var t,n=STR_EMPTY;return _doc||_getDoc(),_doc.v&&(t=_doc.v[strCookie]||STR_EMPTY,_parsedCookieValue!==t&&(_cookieCache=_extractParts(t),_parsedCookieValue=t),n=strTrim(_cookieCache[e]||STR_EMPTY)),n}function _setCookieValue(e,t){_doc||_getDoc(),_doc.v&&(_doc.v[strCookie]=e+"="+t)}function uaDisallowsSameSiteNone(e){return!(!isString(e)||!strContains(e,"CPU iPhone OS 12")&&!strContains(e,"iPad; CPU OS 12")&&!(strContains(e,"Macintosh; Intel Mac OS X 10_14")&&strContains(e,"Version/")&&strContains(e,"Safari"))&&(!strContains(e,"Macintosh; Intel Mac OS X 10_14")||!strEndsWith(e,"AppleWebKit/605.1.15 (KHTML, like Gecko)"))&&!strContains(e,"Chrome/5")&&!strContains(e,"Chrome/6")&&(!strContains(e,"UnrealEngine")||strContains(e,"Chrome"))&&!strContains(e,"UCBrowser/12")&&!strContains(e,"UCBrowser/11"))}var strExecutionContextKey="ctx",strParentContextKey="ParentContextKey",strChildrenContextKey="ChildrenContextKey",PerfEvent=function(){function a(e,t,n){var r,o=this;o.start=utcNow(),o[_DYN_NAME$1]=e,o.isAsync=n,o[_DYN_IS_CHILD_EVT]=function(){return!1},isFunction(t)&&objDefine(o,"payload",{g:function(){return!r&&isFunction(t)&&(r=t(),t=null),r}}),o[_DYN_GET_CTX]=function(e){return e?(e===a[strParentContextKey]||e===a[strChildrenContextKey]?o:o[strExecutionContextKey]||{})[e]:null},o[_DYN_SET_CTX]=function(e,t){e&&(e===a[strParentContextKey]?(o[e]||(o[_DYN_IS_CHILD_EVT]=function(){return!0}),o[e]=t):e===a[strChildrenContextKey]?o[e]=t:(o[strExecutionContextKey]=o[strExecutionContextKey]||{})[e]=t)},o.complete=function(){var e=0,t=o[_DYN_GET_CTX](a[strChildrenContextKey]);if(isArray(t))for(var n=0;n<t[_DYN_LENGTH$2];n++){var r=t[n];r&&(e+=r.time)}o.time=utcNow()-o.start,o.exTime=o.time-e,o.complete=function(){}}}return a.ParentContextKey="parent",a.ChildrenContextKey="childEvts",a}(),doPerfActiveKey="CoreUtils.doPerf";function doPerf(e,t,n,r,o){if(e)if(e=e[STR_GET_PERF_MGR]?e[STR_GET_PERF_MGR]():e){var a,i=void 0,_=e[_DYN_GET_CTX](doPerfActiveKey);try{if(i=e.create(t(),r,o))return _&&i[_DYN_SET_CTX]&&(i[_DYN_SET_CTX](PerfEvent[strParentContextKey],_),_[_DYN_GET_CTX]&&_[_DYN_SET_CTX]&&((a=_[_DYN_GET_CTX](PerfEvent[strChildrenContextKey]))||(a=[],_[_DYN_SET_CTX](PerfEvent[strChildrenContextKey],a)),a[_DYN_PUSH](i))),e[_DYN_SET_CTX](doPerfActiveKey,i),n(i)}catch(s){i&&i[_DYN_SET_CTX]&&i[_DYN_SET_CTX]("exception",s)}finally{i&&e.fire(i),e[_DYN_SET_CTX](doPerfActiveKey,_)}}return n()}function generateW3CId(){for(var e,t=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"],n=STR_EMPTY,r=0;r<4;r++)n+=t[15&(e=random32())]+t[e>>4&15]+t[e>>8&15]+t[e>>12&15]+t[e>>16&15]+t[e>>20&15]+t[e>>24&15]+t[e>>28&15];var o=t[8+(3&random32())|0];return strSubstr(n,0,8)+strSubstr(n,9,4)+"4"+strSubstr(n,13,3)+o+strSubstr(n,16,3)+strSubstr(n,19,12)}var INVALID_TRACE_ID="00000000000000000000000000000000",INVALID_SPAN_ID="0000000000000000";function _isValid(e,t,n){return!(!e||e[_DYN_LENGTH$2]!==t||e===n||!e.match(/^[\da-f]*$/i))}function isValidTraceId(e){return _isValid(e,32,INVALID_TRACE_ID)}function isValidSpanId(e){return _isValid(e,16,INVALID_SPAN_ID)}function findAllScripts(e){var e=e.getElementsByTagName("script"),a=[];return arrForEach(e,function(e){var t,n,r,o=e[_DYN_GET_ATTRIBUTE]("src");o&&(t=e[_DYN_GET_ATTRIBUTE]("crossorigin"),n=!0===e.hasAttribute("async"),r=!0===e.hasAttribute("defer"),e=e[_DYN_GET_ATTRIBUTE]("referrerpolicy"),o={url:o},t&&(o.crossOrigin=t),n&&(o["async"]=n),r&&(o.defer=r),e&&(o.referrerPolicy=e),a[_DYN_PUSH](o))}),a}var pluginStateData=createElmNodeData("plugin");function _getPluginState(e){return pluginStateData.get(e,"state",{},!0)}var _a$1,strTelemetryPluginChain="TelemetryPluginChain",strHasRunFlags="_hasRun",strGetTelCtx="_getTelCtx",_chainId=0;function _getNextProxyStart(e,t,n){for(;e;){if(e[_DYN_GET_PLUGIN]()===n)return e;e=e[_DYN_GET_NEXT]()}return createTelemetryProxyChain([n],t.config||{},t)}function _createInternalContext(e,a,n,t){var r=null,o=[],i=(a=a||createDynamicConfig({},null,n[_DYN_LOGGER]),null!==t&&(r=t?_getNextProxyStart(e,n,t):e),{_next:function(){var e,t=r;return r=t?t[_DYN_GET_NEXT]():null,t||(e=o)&&0<e[_DYN_LENGTH$2]&&(arrForEach(e,function(e){try{e.func.call(e.self,e.args)}catch(t){_throwInternal(n[_DYN_LOGGER],2,73,"Unexpected Exception during onComplete - "+dumpObj(t))}}),o=[]),t},ctx:{core:function(){return n},diagLog:function(){return safeGetLogger(n,a.cfg)},getCfg:function(){return a.cfg},getExtCfg:function(e,t){var r=_(e,!0);return t&&objForEachKey(t,function(e,t){var n;!isNullOrUndefined(r[e])||!(n=a.cfg[e])&&isNullOrUndefined(n)||(r[e]=n),_applyDefaultValue(a,r,e,t)}),a.setDf(r,t)},getConfig:function(e,t,n){void 0===n&&(n=!1);var r,e=_(e,!1),o=a.cfg;return!e||!e[t]&&isNullOrUndefined(e[t])?!o[t]&&isNullOrUndefined(o[t])||(r=o[t]):r=e[t],r||!isNullOrUndefined(r)?r:n},hasNext:function(){return!!r},getNext:function(){return r},setNext:function(e){r=e},iterate:function(e){for(;t=i._next();){var t=t[_DYN_GET_PLUGIN]();t&&e(t)}},onComplete:function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];e&&o[_DYN_PUSH]({func:e,self:isUndefined(t)?i.ctx:t,args:n})}}});function _(e,t){var n,r=null,o=a.cfg;return o&&e&&(n=o[STR_EXTENSION_CONFIG],o[STR_EXTENSION_CONFIG]=n=!n&&t?{}:n,(n=a.ref(o,STR_EXTENSION_CONFIG))&&(r=n[e],n[e]=r=!r&&t?{}:r,r=a.ref(n,e))),r}return i}function createProcessTelemetryContext(e,t,n,r){var o=createDynamicConfig(t),a=_createInternalContext(e,o,n,r),i=a.ctx;return i[_DYN_PROCESS_NEXT]=function(e){var t=a._next();return t&&t[STR_PROCESS_TELEMETRY](e,i),!t},i[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,o.cfg,n,t):e)||i[_DYN_GET_NEXT](),o.cfg,n,t)},i}function createProcessTelemetryUnloadContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t),a=o.ctx;return a[_DYN_PROCESS_NEXT]=function(e){var t=o._next();return t&&t[_DYN_UNLOAD](a,e),!t},a[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUnloadContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||a[_DYN_GET_NEXT](),n,t)},a}function createProcessTelemetryUpdateContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t).ctx;return o[_DYN_PROCESS_NEXT]=function(t){return o.iterate(function(e){isFunction(e[_DYN_UPDATE])&&e[_DYN_UPDATE](o,t)})},o[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUpdateContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||o[_DYN_GET_NEXT](),n,t)},o}function createTelemetryProxyChain(e,t,n,r){var o,a=null,i=!r;return isArray(e)&&0<e[_DYN_LENGTH$2]&&(o=null,arrForEach(e,function(e){(i=!i&&r===e||i)&&e&&isFunction(e[STR_PROCESS_TELEMETRY])&&(e=createTelemetryPluginProxy(e,t,n),a=a||e,o&&o._setNext(e),o=e)})),r&&!a?createTelemetryProxyChain([r],t,n):a}function createTelemetryPluginProxy(s,r,o){var c=null,a=isFunction(s[STR_PROCESS_TELEMETRY]),i=isFunction(s[_DYN_SET_NEXT_PLUGIN]),u=s?s[_DYN_IDENTIFIER]+"-"+s[STR_PRIORITY]+"-"+_chainId++:"Unknown-0-"+_chainId++,_={getPlugin:function(){return s},getNext:function(){return c},processTelemetry:function(n,e){var t;l(e=e||(t=(t=s&&isFunction(s[strGetTelCtx])?s[strGetTelCtx]():t)||createProcessTelemetryContext(_,r,o)),function(e){if(!s||!a)return!1;var t=_getPluginState(s);return!t[_DYN_TEARDOWN]&&!t[STR_DISABLED]&&(i&&s[_DYN_SET_NEXT_PLUGIN](c),s[STR_PROCESS_TELEMETRY](n,e),!0)},"processTelemetry",function(){return{item:n}},!n.sync)||e[_DYN_PROCESS_NEXT](n)},unload:function(r,o){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||(e[STR_CORE]=null,e[_DYN_TEARDOWN]=!0,e[_DYN_IS_INITIALIZED]=!1,s[_DYN_TEARDOWN]&&!0===s[_DYN_TEARDOWN](r,o)&&(n=!0))),n},"unload",function(){},o.isAsync)||r[_DYN_PROCESS_NEXT](o)},update:function(r,o){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||s[_DYN_UPDATE]&&!0===s[_DYN_UPDATE](r,o)&&(n=!0)),n},"update",function(){},!1)||r[_DYN_PROCESS_NEXT](o)},_id:u,_setNext:function(e){c=e}};function l(n,r,o,e,t){var a=!1,i=s?s[_DYN_IDENTIFIER]:strTelemetryPluginChain,_=(_=n[strHasRunFlags])||(n[strHasRunFlags]={});return n.setNext(c),s&&doPerf(n[STR_CORE](),function(){return i+":"+o},function(){_[u]=!0;try{var e=c?c._id:STR_EMPTY;e&&(_[e]=!1),a=r(n)}catch(t){e=!c||_[c._id];e&&(a=!0),c&&e||_throwInternal(n[_DYN_DIAG_LOG$1](),1,73,"Plugin ["+i+"] failed during "+o+" - "+dumpObj(t)+", run flags: "+dumpObj(_))}},e,t),a}return objFreeze(_)}function createUnloadHandlerContainer(){var t=[];return{add:function(e){e&&t[_DYN_PUSH](e)},run:function(n,r){arrForEach(t,function(e){try{e(n,r)}catch(t){_throwInternal(n[_DYN_DIAG_LOG$1](),2,73,"Unexpected error calling unload handler - "+dumpObj(t))}}),t=[]}}}function createUnloadHookContainer(){var t=[];return{run:function(n){var e=t;t=[],arrForEach(e,function(e){try{(e.rm||e.remove).call(e)}catch(t){_throwInternal(n,2,73,"Unloading:"+dumpObj(t))}})},add:function(e){e&&arrAppend(t,e)}}}var strGetPlugin="getPlugin",defaultValues$1=((_a$1={})[STR_EXTENSION_CONFIG]={isVal:isNotNullOrUndefined,v:{}},_a$1),BaseTelemetryPlugin=function(){function e(){var o,a,c,u,l,i=this;function t(e){var t,e=e=void 0===e?null:e;return e||(t=a||createProcessTelemetryContext(null,{},i[STR_CORE]),e=c&&c[strGetPlugin]?t[_DYN_CREATE_NEW](null,c[strGetPlugin]):t[_DYN_CREATE_NEW](null,c)),e}function _(e,t,n){createDynamicConfig(e,defaultValues$1,safeGetLogger(t)),!n&&t&&(n=t[_DYN_GET_PROCESS_TEL_CONT2]()[_DYN_GET_NEXT]());var r=c;c&&c[strGetPlugin]&&(r=c[strGetPlugin]()),i[STR_CORE]=t,a=createProcessTelemetryContext(n,e,t,r)}function E(){o=!1,i[STR_CORE]=null,c=a=null,l=createUnloadHookContainer(),u=createUnloadHandlerContainer()}E(),dynamicProto(e,i,function(s){s[_DYN_INITIALIZE]=function(e,t,n,r){_(e,t,r),o=!0},s[_DYN_TEARDOWN]=function(e,t){var n,r,o,a,i=s[STR_CORE];if(i&&(!e||i===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUnloadContext(null,i,c&&c[strGetPlugin]?c[strGetPlugin]():c),a=t||{reason:0,isAsync:!1},s[_DYN__DO_TEARDOWN]&&!0===s[_DYN__DO_TEARDOWN](o,a,_)?n=!0:_(),n;function _(){r||(r=!0,u.run(o,t),l.run(o[_DYN_DIAG_LOG$1]()),!0===n&&o[_DYN_PROCESS_NEXT](a),E())}},s[_DYN_UPDATE]=function(e,t){var n,r,o,a=s[STR_CORE];if(a&&(!e||a===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUpdateContext(null,a,c&&c[strGetPlugin]?c[strGetPlugin]():c),s._doUpdate&&!0===s._doUpdate(o,t||{reason:0},i)?n=!0:i(),n;function i(){r||(r=!0,_(o.getCfg(),o.core(),o[_DYN_GET_NEXT]()))}},proxyFunctionAs(s,"_addUnloadCb",function(){return u},"add"),proxyFunctionAs(s,"_addHook",function(){return l},"add"),objDefine(s,"_unloadHooks",{g:function(){return l}})}),i[_DYN_DIAG_LOG$1]=function(e){return t(e)[_DYN_DIAG_LOG$1]()},i[_DYN_IS_INITIALIZED]=function(){return o},i.setInitialized=function(e){o=e},i[_DYN_SET_NEXT_PLUGIN]=function(e){c=e},i[_DYN_PROCESS_NEXT]=function(e,t){t?t[_DYN_PROCESS_NEXT](e):c&&isFunction(c[STR_PROCESS_TELEMETRY])&&c[STR_PROCESS_TELEMETRY](e,null)},i._getTelCtx=t}return e.__ieDyn=1,e}(),strOnPrefix="on",strAttachEvent="attachEvent",strAddEventHelper="addEventListener",strDetachEvent="detachEvent",strRemoveEventListener="removeEventListener",strEvents="events",rRemoveEmptyNs=(createUniqueNamespace("aiEvtPageHide"),createUniqueNamespace("aiEvtPageShow"),/\.[\.]+/g),rRemoveTrailingEmptyNs=/[\.]+$/,_guid=1,elmNodeData=createElmNodeData("events"),eventNamespace=/^([^.]*)(?:\.(.+)|)/;function _normalizeNamespace(e){return e&&e[_DYN_REPLACE]?e[_DYN_REPLACE](/^[\s\.]+|(?=[\s\.])[\.\s]+$/g,STR_EMPTY):e}function _getEvtNamespace(e,t){t&&(n=STR_EMPTY,isArray(t)?(n=STR_EMPTY,arrForEach(t,function(e){(e=_normalizeNamespace(e))&&("."!==e[0]&&(e="."+e),n+=e)})):n=_normalizeNamespace(t),n&&("."!==n[0]&&(n="."+n),e=(e||STR_EMPTY)+n));var n,t=eventNamespace.exec(e||STR_EMPTY)||[];return{type:t[1],ns:(t[2]||STR_EMPTY).replace(rRemoveEmptyNs,".").replace(rRemoveTrailingEmptyNs,STR_EMPTY)[_DYN_SPLIT$1](".").sort().join(".")}}function _getRegisteredEvents(e,t,n){e=elmNodeData.get(e,strEvents,{},n=void 0===n||n);return e[t]||(e[t]=[])}function _doDetach(e,t,n,r){e&&t&&t[_DYN_TYPE]&&(e[strRemoveEventListener]?e[strRemoveEventListener](t[_DYN_TYPE],n,r):e[strDetachEvent]&&e[strDetachEvent](strOnPrefix+t[_DYN_TYPE],n))}function _doAttach(e,t,n,r){var o=!1;return e&&t&&t[_DYN_TYPE]&&n&&(e[strAddEventHelper]?(e[strAddEventHelper](t[_DYN_TYPE],n,r),o=!0):e[strAttachEvent]&&(e[strAttachEvent](strOnPrefix+t[_DYN_TYPE],n),o=!0)),o}function _doUnregister(e,t,n,r){for(var o=t[_DYN_LENGTH$2];o--;){var a=t[o];!a||n.ns&&n.ns!==a[_DYN_EVT_NAME].ns||r&&!r(a)||(_doDetach(e,a[_DYN_EVT_NAME],a.handler,a.capture),t[_DYN_SPLICE](o,1))}}function _unregisterEvents(n,r,o){var e;r[_DYN_TYPE]?_doUnregister(n,_getRegisteredEvents(n,r[_DYN_TYPE]),r,o):(objForEachKey(e=elmNodeData.get(n,strEvents,{}),function(e,t){_doUnregister(n,t,r,o)}),0===objKeys(e)[_DYN_LENGTH$2]&&elmNodeData.kill(n,strEvents))}function mergeEvtNamespace(e,t){return t?_getEvtNamespace("xx",isArray(t)?[e].concat(t):[e,t]).ns[_DYN_SPLIT$1]("."):e}function eventOn(e,t,n,r,o){void 0===o&&(o=!1);var a=!1;if(e)try{var i,_=_getEvtNamespace(t,r);(a=_doAttach(e,_,n,o))&&elmNodeData.accept(e)&&(i={guid:_guid++,evtName:_,handler:n,capture:o},_getRegisteredEvents(e,_.type)[_DYN_PUSH](i))}catch(s){}return a}function eventOff(e,t,n,r,o){if(void 0===o&&(o=!1),e)try{var a=_getEvtNamespace(t,r),i=!1;_unregisterEvents(e,a,function(e){return!((!a.ns||n)&&e.handler!==n)&&(i=!0)}),i||_doDetach(e,a,n,o)}catch(_){}}var aiInstrumentHooks="_aiHooks",cbNames=["req","rsp","hkErr","fnErr"];function _arrLoop(e,t){if(e)for(var n=0;n<e[_DYN_LENGTH$2]&&!t(e[n],n);n++);}function _doCallbacks(e,i,_,s,c){0<=c&&c<=2&&_arrLoop(e,function(e,t){var e=e.cbks,n=e[cbNames[c]];if(n){i.ctx=function(){return s[t]=s[t]||{}};try{n[_DYN_APPLY](i.inst,_)}catch(o){n=i.err;try{var r=e[cbNames[2]];r&&(i.err=o,r[_DYN_APPLY](i.inst,_))}catch(a){}finally{i.err=n}}}})}function _createFunctionHook(s){return function(){var n=arguments,e=s.h,r={name:s.n,inst:this,ctx:null,set:function(e,t){(n=a([],n))[e]=t,o=a([r],n)}},t=[],o=a([r],n);function a(t,e){return _arrLoop(e,function(e){t[_DYN_PUSH](e)}),t}r.evt=getInst("event"),_doCallbacks(e,r,o,t,0);var i=s.f;if(i)try{r.rslt=i[_DYN_APPLY](this,n)}catch(_){throw r.err=_,_doCallbacks(e,r,o,t,3),_}return _doCallbacks(e,r,o,t,1),r.rslt}}function _getOwner(e,t,n,r){var o=null;return e&&(objHasOwnProperty(e,t)?o=e:n&&(o=_getOwner(_getObjProto(e),t,r,!1))),o}function _createInstrumentHook(e,t,n,r){var o=n&&n[aiInstrumentHooks],t=(o||((n=_createFunctionHook(o={i:0,n:t,f:n,h:[]}))[aiInstrumentHooks]=o,e[t]=n),{id:o.i,cbks:r,rm:function(){var n=this.id;_arrLoop(o.h,function(e,t){if(e.id===n)return o.h[_DYN_SPLICE](t,1),1})}});return o.i++,o.h[_DYN_PUSH](t),t}function InstrumentEvent(e,t,n,r,o){if(e&&t&&n){r=_getOwner(e,t,r,o)||e;if(r)return _createInstrumentHook(r,t,r[t],n)}return null}var strNotSpecified="not_specified",strIkey="iKey",_DYN_SPLIT="split",_DYN_LENGTH$1="length",_DYN_TO_LOWER_CASE="toLowerCase",_DYN_TO_STRING$1="toString",_DYN_REMOVE_ITEM="removeItem",_DYN_MESSAGE="message",_DYN_COUNT="count",_DYN_STRINGIFY="stringify",_DYN_PATHNAME="pathname",_DYN_MATCH="match",_DYN_NAME="name",_DYN_PROPERTIES$1="properties",_DYN_MEASUREMENTS="measurements",_DYN_SIZE_IN_BYTES="sizeInBytes",_DYN_TYPE_NAME="typeName",_DYN_EXCEPTIONS="exceptions",_DYN_SEVERITY_LEVEL="severityLevel",_DYN_PROBLEM_GROUP="problemGroup",_DYN_PARSED_STACK="parsedStack",_DYN_HAS_FULL_STACK="hasFullStack",_DYN_ASSEMBLY="assembly",_DYN_FILE_NAME="fileName",_DYN_LINE="line",_DYN_AI_DATA_CONTRACT="aiDataContract",_DYN_DURATION$1="duration";function dataSanitizeKeyAndAddUniqueness(e,t,n){var r=t[_DYN_LENGTH$1],o=dataSanitizeKey(e,t);if(o[_DYN_LENGTH$1]!==r){for(var a=0,i=o;n[i]!==undefined;)a++,i=strSubstring(o,0,147)+dsPadNumber(a);o=i}return o}function dataSanitizeKey(e,t){var n;return t&&150<(t=strTrim(asString(t)))[_DYN_LENGTH$1]&&(n=strSubstring(t,0,150),_throwInternal(e,2,57,"name is too long.  It has been truncated to 150 characters.",{name:t},!0)),n||t}function dataSanitizeString(e,t,n){var r;return void 0===n&&(n=1024),t&&(n=n||1024,(t=strTrim(asString(t)))[_DYN_LENGTH$1]>n&&(r=strSubstring(t,0,n),_throwInternal(e,2,61,"string value is too long. It has been truncated to "+n+" characters.",{value:t},!0))),r||t}function dataSanitizeUrl(e,t){return dataSanitizeInput(e,t,2048,66)}function dataSanitizeMessage(e,t){var n;return t&&32768<t[_DYN_LENGTH$1]&&(n=strSubstring(t,0,32768),_throwInternal(e,2,56,"message is too long, it has been truncated to 32768 characters.",{message:t},!0)),n||t}function dataSanitizeException(e,t){var n,r;return t&&32768<(r=""+t)[_DYN_LENGTH$1]&&(n=strSubstring(r,0,32768),_throwInternal(e,2,52,"exception is too long, it has been truncated to 32768 characters.",{exception:t},!0)),n||t}function dataSanitizeProperties(r,e){var o;return e&&(o={},objForEachKey(e,function(e,t){if(isObject(t)&&hasJSON())try{t=getJSON()[_DYN_STRINGIFY](t)}catch(n){_throwInternal(r,2,49,"custom property is not valid",{exception:n},!0)}t=dataSanitizeString(r,t,8192),e=dataSanitizeKeyAndAddUniqueness(r,e,o),o[e]=t}),e=o),e}function dataSanitizeMeasurements(n,e){var r;return e&&(r={},objForEachKey(e,function(e,t){e=dataSanitizeKeyAndAddUniqueness(n,e,r),r[e]=t}),e=r),e}function dataSanitizeId(e,t){return t&&dataSanitizeInput(e,t,128,69)[_DYN_TO_STRING$1]()}function dataSanitizeInput(e,t,n,r){var o;return t&&(t=strTrim(asString(t)))[_DYN_LENGTH$1]>n&&(o=strSubstring(t,0,n),_throwInternal(e,2,r,"input is too long, it has been truncated to "+n+" characters.",{data:t},!0)),o||t}function dsPadNumber(e){e="00"+e;return strSubstr(e,e[_DYN_LENGTH$1]-3)}var _document=getDocument()||{},_htmlAnchorIdx=0,_htmlAnchorElement=[null,null,null,null,null];function urlParseUrl(e){var t=_htmlAnchorIdx,n=_htmlAnchorElement,r=n[t];return _document.createElement?n[t]||(r=n[t]=_document.createElement("a")):r={host:urlParseHost(e,!0)},r.href=e,++t>=n[_DYN_LENGTH$1]&&(t=0),_htmlAnchorIdx=t,r}function urlParseHost(e,t){e=urlParseFullHost(e,t)||"";if(e){t=e[_DYN_MATCH](/(www\d{0,5}\.)?([^\/:]{1,256})(:\d{1,20})?/i);if(null!=t&&3<t[_DYN_LENGTH$1]&&isString(t[2])&&0<t[2][_DYN_LENGTH$1])return t[2]+(t[3]||"")}return e}function urlParseFullHost(e,t){var n=null;return e&&null!=(e=e[_DYN_MATCH](/(\w{1,150}):\/\/([^\/:]{1,256})(:\d{1,20})?/i))&&2<e[_DYN_LENGTH$1]&&isString(e[2])&&0<e[2][_DYN_LENGTH$1]&&(n=e[2]||"",t&&2<e[_DYN_LENGTH$1]&&(t=(e[1]||"")[_DYN_TO_LOWER_CASE](),e=e[3]||"",n+=e="http"===t&&":80"===e||"https"===t&&":443"===e?"":e)),n}function AjaxHelperParseDependencyPath(e,t,n,r){var o,a,i,_=r,s=r,_=t&&0<t[_DYN_LENGTH$1]?(i=(o=urlParseUrl(t)).host,_||(null!=o[_DYN_PATHNAME]?("/"!=((a=0===o.pathname[_DYN_LENGTH$1]?"/":o[_DYN_PATHNAME])[0]||"")&&(a="/"+a),s=o[_DYN_PATHNAME],dataSanitizeString(e,n?n+" "+a:a)):dataSanitizeString(e,t))):i=r;return{target:i,name:_,data:s}}function dateTimeUtilsDuration(e,t){return 0===e||0===t||isNullOrUndefined(e)||isNullOrUndefined(t)?null:t-e}function createDistributedTraceContextFromTrace(e,t){var n=e||{};return{getName:function(){return n[_DYN_NAME]},setName:function(e){t&&t.setName(e),n[_DYN_NAME]=e},getTraceId:function(){return n.traceID},setTraceId:function(e){t&&t.setTraceId(e),isValidTraceId(e)&&(n.traceID=e)},getSpanId:function(){return n.parentID},setSpanId:function(e){t&&t.setSpanId(e),isValidSpanId(e)&&(n.parentID=e)},getTraceFlags:function(){return n.traceFlags},setTraceFlags:function(e){t&&t.setTraceFlags(e),n.traceFlags=e}}}var StorageType=createEnumStyle({LocalStorage:0,SessionStorage:1}),_canUseLocalStorage=undefined,_canUseSessionStorage=undefined,_storagePrefix="";function _getVerifiedStorageObject(e){try{if(isNullOrUndefined(getGlobal()))return null;var t=(new Date)[_DYN_TO_STRING$1](),n=getInst(e===StorageType.LocalStorage?"localStorage":"sessionStorage"),r=_storagePrefix+t,o=(n.setItem(r,t),n.getItem(r)!==t);if(n[_DYN_REMOVE_ITEM](r),!o)return n}catch(a){}return null}function _getSessionStorageObject(){return utlCanUseSessionStorage()?_getVerifiedStorageObject(StorageType.SessionStorage):null}function utlDisableStorage(){_canUseSessionStorage=_canUseLocalStorage=!1}function utlSetStoragePrefix(e){_storagePrefix=e||""}function utlEnableStorage(){_canUseLocalStorage=utlCanUseLocalStorage(!0),_canUseSessionStorage=utlCanUseSessionStorage(!0)}function utlCanUseLocalStorage(e){return _canUseLocalStorage=e||_canUseLocalStorage===undefined?!!_getVerifiedStorageObject(StorageType.LocalStorage):_canUseLocalStorage}function utlCanUseSessionStorage(e){return _canUseSessionStorage=e||_canUseSessionStorage===undefined?!!_getVerifiedStorageObject(StorageType.SessionStorage):_canUseSessionStorage}function utlGetSessionStorage(e,t){var n=_getSessionStorageObject();if(null!==n)try{return n.getItem(t)}catch(r){_canUseSessionStorage=!1,_throwInternal(e,2,2,"Browser failed read of session storage. "+getExceptionName(r),{exception:dumpObj(r)})}return null}function utlSetSessionStorage(e,t,n){var r=_getSessionStorageObject();if(null!==r)try{return r.setItem(t,n),!0}catch(o){_canUseSessionStorage=!1,_throwInternal(e,2,4,"Browser failed write to session storage. "+getExceptionName(o),{exception:dumpObj(o)})}return!1}function utlRemoveSessionStorage(e,t){var n=_getSessionStorageObject();if(null!==n)try{return n[_DYN_REMOVE_ITEM](t),!0}catch(r){_canUseSessionStorage=!1,_throwInternal(e,2,6,"Browser failed removal of session storage item. "+getExceptionName(r),{exception:dumpObj(r)})}return!1}var Event$1=function(){function e(e,t,n,r){this.aiDataContract={ver:1,name:1,properties:0,measurements:0},this.ver=2,this[_DYN_NAME]=dataSanitizeString(e,t)||strNotSpecified,this[_DYN_PROPERTIES$1]=dataSanitizeProperties(e,n),this[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,r)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Event",e.dataType="EventData",e}(),STACKFRAME_BASE_SIZE=58,IS_FRAME=/^\s{0,50}(from\s|at\s|Line\s{1,5}\d{1,10}\s{1,5}of|\w{1,50}@\w{1,80}|[^\(\s\n]+:[0-9\?]+(?::[0-9\?]+)?)/,FULL_STACK_FRAME_1=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\]]+):([0-9\?]+):([0-9\?]+)\)?$/,FULL_STACK_FRAME_2=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\]]+):([0-9\?]+)\)?$/,FULL_STACK_FRAME_3=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\)\]]+)\)?$/,EXTRACT_FILENAME=/(?:^|\(|\s{0,10}[\w\)]+\@)?([^\(\n\s\]\)]+)(?:\:([0-9]+)(?:\:([0-9]+))?)?\)?(?:,|$)/,PARSE_FILENAME_LINE_COL=/([^\(\s\n]+):([0-9]+):([0-9]+)$/,PARSE_FILENAME_LINE_ONLY=/([^\(\s\n]+):([0-9]+)$/,NoMethod="<no_method>",strError="error",strStack="stack",strStackDetails="stackDetails",strErrorSrc="errorSrc",strMessage="message",strDescription="description",_parseSequence=[{re:FULL_STACK_FRAME_1,len:5,m:1,fn:2,ln:3,col:4},{chk:_ignoreNative,pre:_scrubAnonymous,re:FULL_STACK_FRAME_2,len:4,m:1,fn:2,ln:3},{re:FULL_STACK_FRAME_3,len:3,m:1,fn:2,hdl:_handleFilename},{re:EXTRACT_FILENAME,len:2,fn:1,hdl:_handleFilename}];function _scrubAnonymous(e){return e.replace(/(\(anonymous\))/,"<anonymous>")}function _ignoreNative(e){return strIndexOf(e,"[native")<0}function _stringify(e,t){var n=e;return n&&!isString(n)&&(JSON&&JSON[_DYN_STRINGIFY]?(n=JSON[_DYN_STRINGIFY](e),!t||n&&"{}"!==n||(n=isFunction(e[_DYN_TO_STRING$1])?e[_DYN_TO_STRING$1]():""+e)):n=e+" - (Missing JSON.stringify)"),n||""}function _formatMessage(e,t){var n=e;return e&&((n=n&&!isString(n)&&(e[strMessage]||e[strDescription])||n)&&!isString(n)&&(n=_stringify(n,!0)),e.filename&&(n=n+" @"+(e.filename||"")+":"+(e.lineno||"?")+":"+(e.colno||"?"))),(t&&"String"!==t&&"Object"!==t&&"Error"!==t&&-1===strIndexOf(n||"",t)?t+": "+n:n)||""}function _isExceptionDetailsInternal(e){try{if(isObject(e))return"hasFullStack"in e&&"typeName"in e}catch(t){}return!1}function _isExceptionInternal(e){try{if(isObject(e))return"ver"in e&&"exceptions"in e&&"properties"in e}catch(t){}return!1}function _isStackDetails(e){return e&&e.src&&isString(e.src)&&e.obj&&isArray(e.obj)}function _convertStackObj(e){var e=e||"",t=(e=isString(e)?e:isString(e[strStack])?e[strStack]:""+e)[_DYN_SPLIT]("\n");return{src:e,obj:t}}function _getOperaStack(e){for(var t=[],n=e[_DYN_SPLIT]("\n"),r=0;r<n[_DYN_LENGTH$1];r++){var o=n[r];n[r+1]&&(o+="@"+n[r+1],r++),t.push(o)}return{src:e,obj:t}}function _getStackFromErrorObj(e){var t,n=null;if(e)try{e[strStack]?n=_convertStackObj(e[strStack]):e[strError]&&e[strError][strStack]?n=_convertStackObj(e[strError][strStack]):e.exception&&e.exception[strStack]?n=_convertStackObj(e.exception[strStack]):_isStackDetails(e)?n=e:_isStackDetails(e[strStackDetails])?n=e[strStackDetails]:getWindow()&&getWindow().opera&&e[strMessage]?n=_getOperaStack(e[_DYN_MESSAGE]):e.reason&&e.reason[strStack]?n=_convertStackObj(e.reason[strStack]):isString(e)?n=_convertStackObj(e):(t=e[strMessage]||e[strDescription]||"",isString(e[strErrorSrc])&&(t&&(t+="\n"),t+=" from "+e[strErrorSrc]),t&&(n=_convertStackObj(t)))}catch(r){n=_convertStackObj(r)}return n||{src:"",obj:null}}function _formatStackTrace(e){return e?e.obj?e.obj.join("\n"):e.src||"":""}function _parseStack(e){e=e.obj;if(e&&0<e[_DYN_LENGTH$1]){var t=[],n=0,r=!1,o=0;if(arrForEach(e,function(e){(r||_isStackFrame(e))&&(e=asString(e),r=!0,(e=_extractStackFrame(e,n))&&(o+=e[_DYN_SIZE_IN_BYTES],t.push(e),n++))}),32768<o)for(var a=0,i=t[_DYN_LENGTH$1]-1,_=0,s=a,c=i;a<i;){if(32768<(_+=t[a][_DYN_SIZE_IN_BYTES]+t[i][_DYN_SIZE_IN_BYTES])){t.splice(s,c-s+1);break}s=a,c=i,a++,i--}}return t}function _getErrorType(e){var t="";if(e&&!(t=e.typeName||e[_DYN_NAME]||""))try{var n=/function (.{1,200})\(/.exec(e.constructor[_DYN_TO_STRING$1]()),t=n&&1<n[_DYN_LENGTH$1]?n[1]:""}catch(r){}return t}function _formatErrorCode(e){if(e)try{var t,n;if(!isString(e))return t=_getErrorType(e),(n=_stringify(e,!1))&&"{}"!==n||(e[strError]&&(t=_getErrorType(e=e[strError])),n=_stringify(e,!0)),0!==strIndexOf(n,t)&&"String"!==t?t+":"+n:n}catch(r){}return""+(e||"")}var Exception=function(){function a(e,t,n,r,o,a){this.aiDataContract={ver:1,exceptions:1,severityLevel:0,properties:0,measurements:0};var i=this;i.ver=2,_isExceptionInternal(t)?(i[_DYN_EXCEPTIONS]=t[_DYN_EXCEPTIONS]||[],i[_DYN_PROPERTIES$1]=t[_DYN_PROPERTIES$1],i[_DYN_MEASUREMENTS]=t[_DYN_MEASUREMENTS],t[_DYN_SEVERITY_LEVEL]&&(i[_DYN_SEVERITY_LEVEL]=t[_DYN_SEVERITY_LEVEL]),t.id&&(i.id=t.id,t[_DYN_PROPERTIES$1].id=t.id),t[_DYN_PROBLEM_GROUP]&&(i[_DYN_PROBLEM_GROUP]=t[_DYN_PROBLEM_GROUP]),isNullOrUndefined(t.isManual)||(i.isManual=t.isManual)):(n=n||{},a&&(n.id=a),i[_DYN_EXCEPTIONS]=[_createExceptionDetails(e,t,n)],i[_DYN_PROPERTIES$1]=dataSanitizeProperties(e,n),i[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,r),o&&(i[_DYN_SEVERITY_LEVEL]=o),a&&(i.id=a))}return a.CreateAutoException=function(e,t,n,r,o,a,i,_){var s=_getErrorType(o||a||e);return{message:_formatMessage(e,s),url:t,lineNumber:n,columnNumber:r,error:_formatErrorCode(o||a||e),evt:_formatErrorCode(a||e),typeName:s,stackDetails:_getStackFromErrorObj(i||o||a),errorSrc:_}},a.CreateFromInterface=function(t,e,n,r){var o=e[_DYN_EXCEPTIONS]&&arrMap(e[_DYN_EXCEPTIONS],function(e){return _createExDetailsFromInterface(t,e)});return new a(t,__assignFn(__assignFn({},e),{exceptions:o}),n,r)},a.prototype.toInterface=function(){var e=this,t=e.exceptions,n=e.properties,r=e.measurements,o=e.severityLevel,a=e.problemGroup,i=e.id,e=e.isManual;return{ver:"4.0",exceptions:t instanceof Array&&arrMap(t,function(e){return e.toInterface()})||undefined,severityLevel:o,properties:n,measurements:r,problemGroup:a,id:i,isManual:e}},a.CreateSimpleException=function(e,t,n,r,o,a){var i;return{exceptions:[((i={})[_DYN_HAS_FULL_STACK]=!0,i.message=e,i.stack=o,i.typeName=t,i)]}},a.envelopeType="Microsoft.ApplicationInsights.{0}.Exception",a.dataType="ExceptionData",a.formatError=_formatErrorCode,a}(),exDetailsAiDataContract=objFreeze({id:0,outerId:0,typeName:1,message:1,hasFullStack:0,stack:0,parsedStack:2});function _toInterface(){var e=this,t=isArray(e[_DYN_PARSED_STACK])&&arrMap(e[_DYN_PARSED_STACK],function(e){return _parsedFrameToInterface(e)});return{id:e.id,outerId:e.outerId,typeName:e[_DYN_TYPE_NAME],message:e[_DYN_MESSAGE],hasFullStack:e[_DYN_HAS_FULL_STACK],stack:e[strStack],parsedStack:t||undefined}}function _createExceptionDetails(t,e,n){var r,o,a,i,_,s,c;return _isExceptionDetailsInternal(e)?(r=e[_DYN_TYPE_NAME],o=e[_DYN_MESSAGE],i=e[strStack],c=e[_DYN_PARSED_STACK]||[],a=e[_DYN_HAS_FULL_STACK]):(s=(_=e)&&_.evt,isError(_)||(_=_[strError]||s||_),r=dataSanitizeString(t,_getErrorType(_))||strNotSpecified,o=dataSanitizeMessage(t,_formatMessage(e||_,r))||strNotSpecified,c=_parseStack(s=e[strStackDetails]||_getStackFromErrorObj(e)),isArray(c)&&arrMap(c,function(e){e[_DYN_ASSEMBLY]=dataSanitizeString(t,e[_DYN_ASSEMBLY]),e[_DYN_FILE_NAME]=dataSanitizeString(t,e[_DYN_FILE_NAME])}),i=dataSanitizeException(t,_formatStackTrace(s)),a=isArray(c)&&0<c[_DYN_LENGTH$1],n&&(n[_DYN_TYPE_NAME]=n[_DYN_TYPE_NAME]||r)),(_={})[_DYN_AI_DATA_CONTRACT]=exDetailsAiDataContract,_.id=void 0,_.outerId=void 0,_.typeName=r,_.message=o,_[_DYN_HAS_FULL_STACK]=a,_.stack=i,_.parsedStack=c,_.toInterface=_toInterface,_}function _createExDetailsFromInterface(e,t){var n=isArray(t[_DYN_PARSED_STACK])&&arrMap(t[_DYN_PARSED_STACK],function(e){return _stackFrameFromInterface(e)})||t[_DYN_PARSED_STACK];return _createExceptionDetails(e,__assignFn(__assignFn({},t),{parsedStack:n}))}function _parseFilename(e,t){var n=t[_DYN_MATCH](PARSE_FILENAME_LINE_COL);n&&4<=n[_DYN_LENGTH$1]?(e[_DYN_FILE_NAME]=n[1],e[_DYN_LINE]=parseInt(n[2])):(n=t[_DYN_MATCH](PARSE_FILENAME_LINE_ONLY))&&3<=n[_DYN_LENGTH$1]?(e[_DYN_FILE_NAME]=n[1],e[_DYN_LINE]=parseInt(n[2])):e[_DYN_FILE_NAME]=t}function _handleFilename(e,t,n){var r=e[_DYN_FILE_NAME];t.fn&&n&&n[_DYN_LENGTH$1]>t.fn&&(t.ln&&n[_DYN_LENGTH$1]>t.ln?(r=strTrim(n[t.fn]||""),e[_DYN_LINE]=parseInt(strTrim(n[t.ln]||""))||0):r=strTrim(n[t.fn]||"")),r&&_parseFilename(e,r)}function _isStackFrame(e){var t=!1;return e&&isString(e)&&(e=strTrim(e))?IS_FRAME.test(e):t}var stackFrameAiDataContract=objFreeze({level:1,method:1,assembly:0,fileName:0,line:0});function _extractStackFrame(e,t){var n;if(e&&isString(e)&&strTrim(e)){(n={})[_DYN_AI_DATA_CONTRACT]=stackFrameAiDataContract,n.level=t,n.assembly=strTrim(e),n.method=NoMethod,n.fileName="",n.line=0,n.sizeInBytes=0;for(var r=n,o=0;o<_parseSequence[_DYN_LENGTH$1];){var a=_parseSequence[o];if(a.chk&&!a.chk(e))break;var i=(e=a.pre?a.pre(e):e)[_DYN_MATCH](a.re);if(i&&i[_DYN_LENGTH$1]>=a.len){a.m&&(r.method=strTrim(i[a.m]||NoMethod)),a.hdl?a.hdl(r,a,i):a.fn&&(a.ln?(r[_DYN_FILE_NAME]=strTrim(i[a.fn]||""),r[_DYN_LINE]=parseInt(strTrim(i[a.ln]||""))||0):_parseFilename(r,i[a.fn]||""));break}o++}}return _populateFrameSizeInBytes(r)}function _stackFrameFromInterface(e){var t;return(t={})[_DYN_AI_DATA_CONTRACT]=stackFrameAiDataContract,t.level=e.level,t.method=e.method,t.assembly=e[_DYN_ASSEMBLY],t.fileName=e[_DYN_FILE_NAME],t.line=e[_DYN_LINE],t.sizeInBytes=0,_populateFrameSizeInBytes(t)}function _populateFrameSizeInBytes(e){var t=STACKFRAME_BASE_SIZE;return e&&(t=(t+=e.method[_DYN_LENGTH$1])+e.assembly[_DYN_LENGTH$1]+e.fileName[_DYN_LENGTH$1]+e.level.toString()[_DYN_LENGTH$1]+e.line.toString()[_DYN_LENGTH$1],e[_DYN_SIZE_IN_BYTES]=t),e}function _parsedFrameToInterface(e){return{level:e.level,method:e.method,assembly:e[_DYN_ASSEMBLY],fileName:e[_DYN_FILE_NAME],line:e[_DYN_LINE]}}var DataPoint=function(){this.aiDataContract={name:1,kind:0,value:1,count:0,min:0,max:0,stdDev:0},this.kind=0},Metric=function(){function e(e,t,n,r,o,a,i,_,s){this.aiDataContract={ver:1,metrics:1,properties:0},this.ver=2;var c=new DataPoint;c[_DYN_COUNT]=0<r?r:undefined,c.max=isNaN(a)||null===a?undefined:a,c.min=isNaN(o)||null===o?undefined:o,c[_DYN_NAME]=dataSanitizeString(e,t)||strNotSpecified,c.value=n,c.stdDev=isNaN(i)||null===i?undefined:i,this.metrics=[c],this[_DYN_PROPERTIES$1]=dataSanitizeProperties(e,_),this[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,s)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Metric",e.dataType="MetricData",e}(),strEmpty="";function msToTimeSpan(e){e=mathRound(e=isNaN(e)||e<0?0:e);var t=strEmpty+e%1e3,n=strEmpty+mathFloor(e/1e3)%60,r=strEmpty+mathFloor(e/6e4)%60,o=strEmpty+mathFloor(e/36e5)%24,e=mathFloor(e/864e5),t=1===t[_DYN_LENGTH$1]?"00"+t:2===t[_DYN_LENGTH$1]?"0"+t:t,n=n[_DYN_LENGTH$1]<2?"0"+n:n,r=r[_DYN_LENGTH$1]<2?"0"+r:r,o=o[_DYN_LENGTH$1]<2?"0"+o:o;return(0<e?e+".":strEmpty)+o+":"+r+":"+n+"."+t}function isCrossOriginError(e,t,n,r,o){return!o&&isString(e)&&("Script error."===e||"Script error"===e)}var PageView=function(){function e(e,t,n,r,o,a,i){this.aiDataContract={ver:1,name:0,url:0,duration:0,properties:0,measurements:0,id:0};var _=this;_.ver=2,_.id=dataSanitizeId(e,i),_.url=dataSanitizeUrl(e,n),_[_DYN_NAME]=dataSanitizeString(e,t)||strNotSpecified,isNaN(r)||(_[_DYN_DURATION$1]=msToTimeSpan(r)),_[_DYN_PROPERTIES$1]=dataSanitizeProperties(e,o),_[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,a)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Pageview",e.dataType="PageviewData",e}(),RemoteDependencyData=function(){function e(e,t,n,r,o,a,i,_,s,c,u,l){void 0===s&&(s="Ajax"),this.aiDataContract={id:1,ver:1,name:0,resultCode:0,duration:0,success:0,data:0,target:0,type:0,properties:0,measurements:0,kind:0,value:0,count:0,min:0,max:0,stdDev:0,dependencyKind:0,dependencySource:0,commandName:0,dependencyTypeName:0};var E=this,t=(E.ver=2,E.id=t,E[_DYN_DURATION$1]=msToTimeSpan(o),E.success=a,E.resultCode=i+"",E.type=dataSanitizeString(e,s),AjaxHelperParseDependencyPath(e,n,_,r));E.data=dataSanitizeUrl(e,r)||t.data,E.target=dataSanitizeString(e,t.target),c&&(E.target="".concat(E.target," | ").concat(c)),E[_DYN_NAME]=dataSanitizeString(e,t[_DYN_NAME]),E[_DYN_PROPERTIES$1]=dataSanitizeProperties(e,u),E[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,l)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.RemoteDependency",e.dataType="RemoteDependencyData",e}(),Trace=function(){function e(e,t,n,r,o){this.aiDataContract={ver:1,message:1,severityLevel:0,properties:0};var a=this;a.ver=2,a[_DYN_MESSAGE]=dataSanitizeMessage(e,t=t||strNotSpecified),a[_DYN_PROPERTIES$1]=dataSanitizeProperties(e,r),a[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,o),n&&(a[_DYN_SEVERITY_LEVEL]=n)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Message",e.dataType="MessageData",e}(),PageViewPerformance=function(){function e(e,t,n,r,o,a,i){this.aiDataContract={ver:1,name:0,url:0,duration:0,perfTotal:0,networkConnect:0,sentRequest:0,receivedResponse:0,domProcessing:0,properties:0,measurements:0};var _=this;_.ver=2,_.url=dataSanitizeUrl(e,n),_[_DYN_NAME]=dataSanitizeString(e,t)||strNotSpecified,_[_DYN_PROPERTIES$1]=dataSanitizeProperties(e,o),_[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,a),i&&(_.domProcessing=i.domProcessing,_[_DYN_DURATION$1]=i[_DYN_DURATION$1],_.networkConnect=i.networkConnect,_.perfTotal=i.perfTotal,_.receivedResponse=i.receivedResponse,_.sentRequest=i.sentRequest)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.PageviewPerformance",e.dataType="PageviewPerformanceData",e}();function createTelemetryItem(e,t,n,r,o,a){n=dataSanitizeString(r,n)||strNotSpecified,(isNullOrUndefined(e)||isNullOrUndefined(t)||isNullOrUndefined(n))&&throwError("Input doesn't contain all required fields");var r="",i=(e[strIkey]&&(r=e[strIkey],delete e[strIkey]),{name:n,time:toISOString(new Date),iKey:r,ext:a||{},tags:[],data:{},baseType:t,baseData:e});return isNullOrUndefined(o)||objForEachKey(o,function(e,t){i.data[e]=t}),i}function createDomEvent(e){var t,n=null;return isFunction(Event)?n=new Event(e):(t=getDocument())&&t.createEvent&&(n=t.createEvent("Event")).initEvent(e,!0,!0),n}var PropertiesPluginIdentifier="AppInsightsPropertiesPlugin",AnalyticsPluginIdentifier="ApplicationInsightsAnalytics",_DYN_TO_STRING="toString",_DYN_IS_STORAGE_USE_DISAB0="isStorageUseDisabled",_DYN__ADD_HOOK="_addHook",_DYN_CORE="core",_DYN_DATA_TYPE="dataType",_DYN_ENVELOPE_TYPE="envelopeType",_DYN_DIAG_LOG="diagLog",_DYN_TRACK="track",_DYN_TRACK_PAGE_VIEW="trackPageView",_DYN_TRACK_PREVIOUS_PAGE_1="trackPreviousPageVisit",_DYN_SEND_PAGE_VIEW_INTER2="sendPageViewInternal",_DYN_START_TIME="startTime",_DYN_PROPERTIES="properties",_DYN_DURATION="duration",_DYN_SEND_PAGE_VIEW_PERFO3="sendPageViewPerformanceInternal",_DYN_POPULATE_PAGE_VIEW_P4="populatePageViewPerformanceEvent",_DYN_HREF="href",_DYN_SEND_EXCEPTION_INTER5="sendExceptionInternal",_DYN_ERROR="error",_DYN_LINE_NUMBER="lineNumber",_DYN_COLUMN_NUMBER="columnNumber",_DYN__CREATE_AUTO_EXCEPTI6="CreateAutoException",_DYN_ADD_TELEMETRY_INITIA7="addTelemetryInitializer",_DYN_OVERRIDE_PAGE_VIEW_D8="overridePageViewDuration",_DYN_AUTO_EXCEPTION_INSTR9="autoExceptionInstrumented",_DYN_AUTO_TRACK_PAGE_VISI10="autoTrackPageVisitTime",_DYN_IS_BROWSER_LINK_TRAC11="isBrowserLinkTrackingEnabled",_DYN_LENGTH="length",_DYN_ENABLE_AUTO_ROUTE_TR12="enableAutoRouteTracking",_DYN_ENABLE_UNHANDLED_PRO13="enableUnhandledPromiseRejectionTracking",_DYN_AUTO_UNHANDLED_PROMI14="autoUnhandledPromiseInstrumented",_DYN_GET_ENTRIES_BY_TYPE="getEntriesByType",_DYN_IS_PERFORMANCE_TIMIN15="isPerformanceTimingSupported",_DYN_GET_PERFORMANCE_TIMI16="getPerformanceTiming",_DYN_NAVIGATION_START="navigationStart",_DYN_SHOULD_COLLECT_DURAT17="shouldCollectDuration",_DYN_IS_PERFORMANCE_TIMIN18="isPerformanceTimingDataReady",_DYN_RESPONSE_START="responseStart",_DYN_REQUEST_START="requestStart",_DYN_LOAD_EVENT_END="loadEventEnd",_DYN_RESPONSE_END="responseEnd",_DYN_CONNECT_END="connectEnd",PageViewManager=function(){function e(D,g,t,T){dynamicProto(e,this,function(e){var u,r=null,o=[],l=!1,E=!1;function N(e){t&&t.flush(e,function(){})}function f(e){o.push(e),function n(){r=r||scheduleTimeout(function(){r=null;var e=o.slice(0),t=!1;o=[],arrForEach(e,function(e){e()?t=!0:o.push(e)}),0<o[_DYN_LENGTH]&&n(),t&&N(!0)},100)}()}t&&(u=t.logger),e[_DYN_TRACK_PAGE_VIEW]=function(r,o){var e,t,a=r.name,i=(!isNullOrUndefined(a)&&"string"==typeof a||(t=getDocument(),a=r.name=t&&t.title||""),r.uri);if(!isNullOrUndefined(i)&&"string"==typeof i||(t=getLocation(),i=r.uri=t&&t[_DYN_HREF]||""),E||((e=(t=getPerformance())&&t[_DYN_GET_ENTRIES_BY_TYPE]&&t[_DYN_GET_ENTRIES_BY_TYPE]("navigation"))&&e[0]&&!isUndefined(t.timeOrigin)?(e=e[0].loadEventStart,r[_DYN_START_TIME]=new Date(t.timeOrigin+e)):(t=(o||r[_DYN_PROPERTIES]||{})[_DYN_DURATION]||0,r[_DYN_START_TIME]=new Date((new Date).getTime()-t)),E=!0),!T[_DYN_IS_PERFORMANCE_TIMIN15]())return D[_DYN_SEND_PAGE_VIEW_INTER2](r,o),N(!0),void(isWebWorker()||_throwInternal(u,2,25,"trackPageView: navigation timing API used for calculation of page duration is not supported in this browser. This page view will be collected without duration and timing info."));var _,n,s=!1,c=T[_DYN_GET_PERFORMANCE_TIMI16]()[_DYN_NAVIGATION_START];0<c&&(_=dateTimeUtilsDuration(c,+new Date),T[_DYN_SHOULD_COLLECT_DURAT17](_)||(_=undefined)),isNullOrUndefined(o)||isNullOrUndefined(o[_DYN_DURATION])||(n=o[_DYN_DURATION]),!g&&isNaN(n)||(isNaN(n)&&((o=o||{})[_DYN_DURATION]=_),D[_DYN_SEND_PAGE_VIEW_INTER2](r,o),N(!0),s=!0),o=o||{},f(function(){var e,t=!1;try{T[_DYN_IS_PERFORMANCE_TIMIN18]()?(t=!0,e={name:a,uri:i},T[_DYN_POPULATE_PAGE_VIEW_P4](e),e.isValid||s?(s||(o[_DYN_DURATION]=e.durationMs,D[_DYN_SEND_PAGE_VIEW_INTER2](r,o)),l||(D[_DYN_SEND_PAGE_VIEW_PERFO3](e,o),l=!0)):(o[_DYN_DURATION]=_,D[_DYN_SEND_PAGE_VIEW_INTER2](r,o))):0<c&&6e4<dateTimeUtilsDuration(c,+new Date)&&(t=!0,s||(o[_DYN_DURATION]=6e4,D[_DYN_SEND_PAGE_VIEW_INTER2](r,o)))}catch(n){_throwInternal(u,1,38,"trackPageView failed on page load calculation: "+getExceptionName(n),{exception:dumpObj(n)})}return t})},e.teardown=function(e,t){var n;r&&(r.cancel(),r=null,n=o.slice(0),o=[],arrForEach(n,function(e){e()}))}})}return e.__ieDyn=1,e}(),MAX_DURATION_ALLOWED=36e5,botAgentNames=["googlebot","adsbot-google","apis-google","mediapartners-google"];function _isPerformanceTimingSupported(){var e=getPerformance();return e&&!!e.timing}function _isPerformanceNavigationTimingSupported(){var e=getPerformance();return e&&e.getEntriesByType&&0<e.getEntriesByType("navigation")[_DYN_LENGTH]}function _isPerformanceTimingDataReady(){var e=getPerformance(),e=e?e.timing:0;return e&&0<e.domainLookupStart&&0<e[_DYN_NAVIGATION_START]&&0<e[_DYN_RESPONSE_START]&&0<e[_DYN_REQUEST_START]&&0<e[_DYN_LOAD_EVENT_END]&&0<e[_DYN_RESPONSE_END]&&0<e[_DYN_CONNECT_END]&&0<e.domLoading}function _getPerformanceTiming(){return _isPerformanceTimingSupported()?getPerformance().timing:null}function _getPerformanceNavigationTiming(){return _isPerformanceNavigationTimingSupported()?getPerformance()[_DYN_GET_ENTRIES_BY_TYPE]("navigation")[0]:null}function _shouldCollectDuration(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n=(getNavigator()||{}).userAgent,r=!1;if(n)for(var o=0;o<botAgentNames[_DYN_LENGTH];o++)r=r||-1!==strIndexOf(n.toLowerCase(),botAgentNames[o]);if(r)return!1;for(o=0;o<e[_DYN_LENGTH];o++)if(e[o]<0||e[o]>=MAX_DURATION_ALLOWED)return!1;return!0}var _a,PageViewPerformanceManager=function(){function t(e){var s=safeGetLogger(e);dynamicProto(t,this,function(_){_[_DYN_POPULATE_PAGE_VIEW_P4]=function(e){e.isValid=!1;var t=_getPerformanceNavigationTiming(),n=_getPerformanceTiming(),r=0,o=0,a=0,i=0;(t||n)&&(t=t?(r=t[_DYN_DURATION],o=0===t[_DYN_START_TIME]?t[_DYN_CONNECT_END]:dateTimeUtilsDuration(t[_DYN_START_TIME],t[_DYN_CONNECT_END]),a=dateTimeUtilsDuration(t.requestStart,t[_DYN_RESPONSE_START]),i=dateTimeUtilsDuration(t[_DYN_RESPONSE_START],t[_DYN_RESPONSE_END]),dateTimeUtilsDuration(t.responseEnd,t[_DYN_LOAD_EVENT_END])):(r=dateTimeUtilsDuration(n[_DYN_NAVIGATION_START],n[_DYN_LOAD_EVENT_END]),o=dateTimeUtilsDuration(n[_DYN_NAVIGATION_START],n[_DYN_CONNECT_END]),a=dateTimeUtilsDuration(n.requestStart,n[_DYN_RESPONSE_START]),i=dateTimeUtilsDuration(n[_DYN_RESPONSE_START],n[_DYN_RESPONSE_END]),dateTimeUtilsDuration(n.responseEnd,n[_DYN_LOAD_EVENT_END])),0===r?_throwInternal(s,2,10,"error calculating page view performance.",{total:r,network:o,request:a,response:i,dom:t}):_[_DYN_SHOULD_COLLECT_DURAT17](r,o,a,i,t)?r<mathFloor(o)+mathFloor(a)+mathFloor(i)+mathFloor(t)?_throwInternal(s,2,8,"client performance math error.",{total:r,network:o,request:a,response:i,dom:t}):(e.durationMs=r,e.perfTotal=e[_DYN_DURATION]=msToTimeSpan(r),e.networkConnect=msToTimeSpan(o),e.sentRequest=msToTimeSpan(a),e.receivedResponse=msToTimeSpan(i),e.domProcessing=msToTimeSpan(t),e.isValid=!0):_throwInternal(s,2,45,"Invalid page load duration value. Browser perf data won't be sent.",{total:r,network:o,request:a,response:i,dom:t}))},_[_DYN_GET_PERFORMANCE_TIMI16]=_getPerformanceTiming,_[_DYN_IS_PERFORMANCE_TIMIN15]=_isPerformanceTimingSupported,_[_DYN_IS_PERFORMANCE_TIMIN18]=_isPerformanceTimingDataReady,_[_DYN_SHOULD_COLLECT_DURAT17]=_shouldCollectDuration})}return t.__ieDyn=1,t}(),PageVisitTimeManager=function(){function e(i,_){var s="prevPageVisitData";dynamicProto(e,this,function(e){function o(e,t){var n=null;try{var r,n=a();utlCanUseSessionStorage()&&(null!=utlGetSessionStorage(i,s)&&throwError("Cannot call startPageVisit consecutively without first calling stopPageVisit"),r=getJSON().stringify(new PageVisitData(e,t)),utlSetSessionStorage(i,s,r))}catch(o){_warnToConsole(i,"Call to restart failed: "+dumpObj(o)),n=null}return n}function a(){var e,t,n=null;try{utlCanUseSessionStorage()&&(e=utcNow(),(t=utlGetSessionStorage(i,s))&&hasJSON()&&((n=getJSON().parse(t)).pageVisitTime=e-n.pageVisitStartTime,utlRemoveSessionStorage(i,s)))}catch(r){_warnToConsole(i,"Stop page visit timer failed: "+dumpObj(r)),n=null}return n}e[_DYN_TRACK_PREVIOUS_PAGE_1]=function(e,t){try{var n=o(e,t);n&&_(n.pageName,n.pageUrl,n.pageVisitTime)}catch(r){_warnToConsole(i,"Auto track page visit time failed, metric will not be collected: "+dumpObj(r))}},objDefine(e,"_logger",{g:function(){return i}}),objDefine(e,"pageVisitTimeTrackingHandler",{g:function(){return _}})})}return e.__ieDyn=1,e}(),PageVisitData=function(e,t){this.pageVisitStartTime=utcNow(),this.pageName=e,this.pageUrl=t},Timing=function(a,e){var i=this,_={};i.start=function(e){"undefined"!=typeof _[e]&&_throwInternal(a,2,62,"start was called more than once for this event without calling stop.",{name:e,key:e},!0),_[e]=+new Date},i.stop=function(e,t,n,r){var o=_[e];isNaN(o)?_throwInternal(a,2,63,"stop was called without a corresponding start.",{name:e,key:e},!0):(o=dateTimeUtilsDuration(o,+new Date),i.action(e,t,o,n,r)),delete _[e],_[e]=undefined}},strEvent="event";function _dispatchEvent(e,t){e&&e.dispatchEvent&&t&&e.dispatchEvent(t)}function _getReason(e){var t;return e&&e.reason?(t=e.reason,!isString(t)&&isFunction(t[_DYN_TO_STRING])?t[_DYN_TO_STRING]():dumpObj(t)):e||""}var MinMilliSeconds=6e4,defaultValues=objDeepFreeze(((_a={sessionRenewalMs:cfgDfSet(_chkConfigMilliseconds,18e5),sessionExpirationMs:cfgDfSet(_chkConfigMilliseconds,864e5),disableExceptionTracking:cfgDfBoolean()})[_DYN_AUTO_TRACK_PAGE_VISI10]=cfgDfBoolean(),_a[_DYN_OVERRIDE_PAGE_VIEW_D8]=cfgDfBoolean(),_a[_DYN_ENABLE_UNHANDLED_PRO13]=cfgDfBoolean(),_a[_DYN_AUTO_UNHANDLED_PROMI14]=!1,_a.samplingPercentage=cfgDfValidate(_chkSampling,100),_a[_DYN_IS_STORAGE_USE_DISAB0]=cfgDfBoolean(),_a[_DYN_IS_BROWSER_LINK_TRAC11]=cfgDfBoolean(),_a[_DYN_ENABLE_AUTO_ROUTE_TR12]=cfgDfBoolean(),_a.namePrefix=cfgDfString(),_a.enableDebug=cfgDfBoolean(),_a.disableFlushOnBeforeUnload=cfgDfBoolean(),_a.disableFlushOnUnload=cfgDfBoolean(!1,"disableFlushOnBeforeUnload"),_a.expCfg=cfgDfMerge({inclScripts:!1,expLog:undefined,maxLogs:50}),_a));function _chkConfigMilliseconds(e,t){return+((e=e||t)<MinMilliSeconds?MinMilliSeconds:e)}function _chkSampling(e){return!isNaN(e)&&0<e&&e<=100}function _updateStorageUsage(e){isUndefined(e[_DYN_IS_STORAGE_USE_DISAB0])||(e[_DYN_IS_STORAGE_USE_DISAB0]?utlDisableStorage:utlEnableStorage)()}var AnalyticsPlugin=function(t){function n(){var T,d,S,p,m,y,P,O,Y,A,I,C,R,v,b,h,L,U,M,G,w,e=t.call(this)||this;return e.identifier=AnalyticsPluginIdentifier,e.priority=180,e.autoRoutePVDelay=500,dynamicProto(n,e,function(f,D){var g=D[_DYN__ADD_HOOK];function l(e,t,n,r,o){f[_DYN_DIAG_LOG]().throwInternal(e,t,n,r,o)}function n(){y=m=p=S=d=T=null;var e=getLocation(!(h=v=R=C=I=A=Y=O=P=!1));U=e&&e[_DYN_HREF]||"",b=G=M=null,w=0,objDefine(f,"config",{g:function(){return b}})}n(),f.getCookieMgr=function(){return safeGetCookieMgr(f[_DYN_CORE])},f.processTelemetry=function(e,t){f.processNext(e,t)},f.trackEvent=function(e,t){try{var n=createTelemetryItem(e,Event$1[_DYN_DATA_TYPE],Event$1[_DYN_ENVELOPE_TYPE],f[_DYN_DIAG_LOG](),t);f[_DYN_CORE][_DYN_TRACK](n)}catch(r){l(2,39,"trackTrace failed, trace will not be collected: "+getExceptionName(r),{exception:dumpObj(r)})}},f.startTrackEvent=function(e){try{T.start(e)}catch(t){l(1,29,"startTrackEvent failed, event will not be collected: "+getExceptionName(t),{exception:dumpObj(t)})}},f.stopTrackEvent=function(e,t,n){try{T.stop(e,undefined,t,n)}catch(r){l(1,30,"stopTrackEvent failed, event will not be collected: "+getExceptionName(r),{exception:dumpObj(r)})}},f.trackTrace=function(e,t){try{var n=createTelemetryItem(e,Trace[_DYN_DATA_TYPE],Trace[_DYN_ENVELOPE_TYPE],f[_DYN_DIAG_LOG](),t);f[_DYN_CORE][_DYN_TRACK](n)}catch(r){l(2,39,"trackTrace failed, trace will not be collected: "+getExceptionName(r),{exception:dumpObj(r)})}},f.trackMetric=function(e,t){try{var n=createTelemetryItem(e,Metric[_DYN_DATA_TYPE],Metric[_DYN_ENVELOPE_TYPE],f[_DYN_DIAG_LOG](),t);f[_DYN_CORE][_DYN_TRACK](n)}catch(r){l(1,36,"trackMetric failed, metric will not be collected: "+getExceptionName(r),{exception:dumpObj(r)})}},f[_DYN_TRACK_PAGE_VIEW]=function(e,t){try{var n=e||{};S[_DYN_TRACK_PAGE_VIEW](n,__assignFn(__assignFn(__assignFn({},n.properties),n.measurements),t)),h&&m[_DYN_TRACK_PREVIOUS_PAGE_1](n.name,n.uri)}catch(r){l(1,37,"trackPageView failed, page view will not be collected: "+getExceptionName(r),{exception:dumpObj(r)})}},f[_DYN_SEND_PAGE_VIEW_INTER2]=function(e,t,n){var r=getDocument(),r=(r&&(e.refUri=e.refUri===undefined?r.referrer:e.refUri),isNullOrUndefined(e[_DYN_START_TIME])&&(r=(t||e[_DYN_PROPERTIES]||{})[_DYN_DURATION]||0,e[_DYN_START_TIME]=new Date((new Date).getTime()-r)),createTelemetryItem(e,PageView[_DYN_DATA_TYPE],PageView[_DYN_ENVELOPE_TYPE],f[_DYN_DIAG_LOG](),t,n));f[_DYN_CORE][_DYN_TRACK](r)},f[_DYN_SEND_PAGE_VIEW_PERFO3]=function(e,t,n){e=createTelemetryItem(e,PageViewPerformance[_DYN_DATA_TYPE],PageViewPerformance[_DYN_ENVELOPE_TYPE],f[_DYN_DIAG_LOG](),t,n);f[_DYN_CORE][_DYN_TRACK](e)},f.trackPageViewPerformance=function(e,t){e=e||{};try{p[_DYN_POPULATE_PAGE_VIEW_P4](e),f[_DYN_SEND_PAGE_VIEW_PERFO3](e,t)}catch(n){l(1,37,"trackPageViewPerformance failed, page view will not be collected: "+getExceptionName(n),{exception:dumpObj(n)})}},f.startTrackPage=function(e){try{var t;"string"!=typeof e&&(e=(t=getDocument())&&t.title||""),d.start(e)}catch(n){l(1,31,"startTrackPage failed, page view may not be collected: "+getExceptionName(n),{exception:dumpObj(n)})}},f.stopTrackPage=function(e,t,n,r){try{var o,a;"string"!=typeof e&&(e=(o=getDocument())&&o.title||""),"string"!=typeof t&&(t=(a=getLocation())&&a[_DYN_HREF]||""),d.stop(e,t,n,r),h&&m[_DYN_TRACK_PREVIOUS_PAGE_1](e,t)}catch(i){l(1,32,"stopTrackPage failed, page view will not be collected: "+getExceptionName(i),{exception:dumpObj(i)})}},f[_DYN_SEND_EXCEPTION_INTER5]=function(e,t,n){var r=e&&(e.exception||e[_DYN_ERROR])||isError(e)&&e||{name:e&&typeof e,message:e||strNotSpecified},r=(e=e||{},new Exception(f[_DYN_DIAG_LOG](),r,e[_DYN_PROPERTIES]||t,e.measurements,e.severityLevel,e.id).toInterface()),e=getDocument(),e=(e&&null!=L&&L.inclScripts&&(e=findAllScripts(e),r[_DYN_PROPERTIES].exceptionScripts=JSON.stringify(e)),null!=L&&L.expLog&&(e=L.expLog())&&e.logs&&isArray(e.logs)&&(r[_DYN_PROPERTIES].exceptionLog=e.logs.slice(0,L.maxLogs).join("\n")),createTelemetryItem(r,Exception[_DYN_DATA_TYPE],Exception[_DYN_ENVELOPE_TYPE],f[_DYN_DIAG_LOG](),t,n));f[_DYN_CORE][_DYN_TRACK](e)},f.trackException=function(e,t){e&&!e.exception&&e[_DYN_ERROR]&&(e.exception=e[_DYN_ERROR]);try{f[_DYN_SEND_EXCEPTION_INTER5](e,t)}catch(n){l(1,35,"trackException failed, exception will not be collected: "+getExceptionName(n),{exception:dumpObj(n)})}},f._onerror=function(e){var t,n,r,o=e&&e[_DYN_ERROR],a=e&&e.evt;try{a||(c=getWindow())&&(a=c[strEvent]);var i=e&&e.url||(getDocument()||{}).URL,_=e.errorSrc||"window.onerror@"+i+":"+(e[_DYN_LINE_NUMBER]||0)+":"+(e[_DYN_COLUMN_NUMBER]||0),s={errorSrc:_,url:i,lineNumber:e[_DYN_LINE_NUMBER]||0,columnNumber:e[_DYN_COLUMN_NUMBER]||0,message:e.message};isCrossOriginError(e.message,e.url,e.lineNumber,e.columnNumber,e[_DYN_ERROR])?(t=Exception[_DYN__CREATE_AUTO_EXCEPTI6]("Script error: The browser's same-origin policy prevents us from getting the details of this exception. Consider using the 'crossorigin' attribute.",i,e[_DYN_LINE_NUMBER]||0,e[_DYN_COLUMN_NUMBER]||0,o,a,null,_),n=s,r=createTelemetryItem(t,Exception[_DYN_DATA_TYPE],Exception[_DYN_ENVELOPE_TYPE],f[_DYN_DIAG_LOG](),n),f[_DYN_CORE][_DYN_TRACK](r)):(e.errorSrc||(e.errorSrc=_),f.trackException({exception:e,severityLevel:3},s))}catch(u){var c=o?o.name+", "+o.message:"null";l(1,11,"_onError threw exception while logging error, error will not be collected: "+getExceptionName(u),{exception:dumpObj(u),errorString:c})}},f[_DYN_ADD_TELEMETRY_INITIA7]=function(e){if(f[_DYN_CORE])return f[_DYN_CORE][_DYN_ADD_TELEMETRY_INITIA7](e);(y=y||[]).push(e)},f.initialize=function(e,t,n,r){if(!f.isInitialized()){isNullOrUndefined(t)&&throwError("Error initializing"),D.initialize(e,t,n,r);try{var o,a;G=mergeEvtNamespace(createUniqueNamespace(f.identifier),t.evtNamespace&&t.evtNamespace()),y&&(arrForEach(y,function(e){t[_DYN_ADD_TELEMETRY_INITIA7](e)}),y=null),u=e,l=f.identifier,E=f[_DYN_CORE],f[_DYN__ADD_HOOK](onConfigChange(u,function(){var r,e=createProcessTelemetryContext(null,u,E);b=e.getExtCfg(l,defaultValues),C=C||u[_DYN_AUTO_EXCEPTION_INSTR9]||b[_DYN_AUTO_EXCEPTION_INSTR9],L=b.expCfg,h=b[_DYN_AUTO_TRACK_PAGE_VISI10],u.storagePrefix&&utlSetStoragePrefix(u.storagePrefix),_updateStorageUsage(b),P=b[_DYN_IS_BROWSER_LINK_TRAC11],!O&&P&&(r=["/browserLinkSignalR/","/__browserLink/"],f[_DYN__ADD_HOOK](f[_DYN_ADD_TELEMETRY_INITIA7](function(e){if(P&&e.baseType===RemoteDependencyData[_DYN_DATA_TYPE]){var t=e.baseData;if(t)for(var n=0;n<r[_DYN_LENGTH];n++)if(t.target&&0<=strIndexOf(t.target,r[n]))return!1}return!0})),O=!0)})),p=new PageViewPerformanceManager(f[_DYN_CORE]),S=new PageViewManager(f,b.overridePageViewDuration,f[_DYN_CORE],p),m=new PageVisitTimeManager(f[_DYN_DIAG_LOG](),function(e,t,n){f.trackMetric({name:"PageVisitTime",average:n,max:n,min:n,sampleCount:1},{PageName:e,PageUrl:t})}),(T=new Timing(f[_DYN_DIAG_LOG](),"trackEvent")).action=function(e,t,n,r,o){o=o||{},(r=r||{}).duration=n[_DYN_TO_STRING](),f.trackEvent({name:e,properties:r,measurements:o})},(d=new Timing(f[_DYN_DIAG_LOG](),"trackPageView")).action=function(e,t,n,r,o){(r=isNullOrUndefined(r)?{}:r).duration=n[_DYN_TO_STRING](),f[_DYN_SEND_PAGE_VIEW_INTER2]({name:e,uri:t,properties:r,measurements:o},r)},hasWindow()&&(s=getWindow(),c=getLocation(!0),f[_DYN__ADD_HOOK](onConfigChange(b,function(){(I=b.disableExceptionTracking)||C||b[_DYN_AUTO_EXCEPTION_INSTR9]||(g(InstrumentEvent(s,"onerror",{ns:G,rsp:function(e,t,n,r,o,a){I||!0===e.rslt||f._onerror(Exception[_DYN__CREATE_AUTO_EXCEPTI6](t,n,r,o,a,e.evt))}},!1)),w++,C=!0)})),o=s,a=c,f[_DYN__ADD_HOOK](onConfigChange(b,function(){R=!0===b[_DYN_ENABLE_UNHANDLED_PRO13],C=C||b[_DYN_AUTO_UNHANDLED_PROMI14],R&&!v&&(g(InstrumentEvent(o,"onunhandledrejection",{ns:G,rsp:function(e,t){R&&!0!==e.rslt&&f._onerror(Exception[_DYN__CREATE_AUTO_EXCEPTI6](_getReason(t),a?a[_DYN_HREF]:"",0,0,t,e.evt))}},!1)),w++,b[_DYN_AUTO_UNHANDLED_PROMI14]=v=!0)})),i=getWindow(),_=getLocation(!0),f[_DYN__ADD_HOOK](onConfigChange(b,function(){var e,t,n,r;Y=!0===b[_DYN_ENABLE_AUTO_ROUTE_TR12],i&&Y&&!A&&hasHistory()&&(t=getHistory(),isFunction(t.pushState)&&isFunction(t.replaceState)&&typeof Event!==strShimUndefined&&(e=i,t=t,n=_,A||(r=b.namePrefix||"",g(InstrumentEvent(t,"pushState",{ns:G,rsp:function(){Y&&(_dispatchEvent(e,createDomEvent(r+"pushState")),_dispatchEvent(e,createDomEvent(r+"locationchange")))}},!0)),g(InstrumentEvent(t,"replaceState",{ns:G,rsp:function(){Y&&(_dispatchEvent(e,createDomEvent(r+"replaceState")),_dispatchEvent(e,createDomEvent(r+"locationchange")))}},!0)),eventOn(e,r+"popstate",function(){Y&&_dispatchEvent(e,createDomEvent(r+"locationchange"))},G),eventOn(e,r+"locationchange",function(){var e,t;M&&(U=M),M=n&&n[_DYN_HREF]||"",Y&&(t=null,(t=f[_DYN_CORE]&&f[_DYN_CORE].getTraceCtx?f[_DYN_CORE].getTraceCtx(!1):t)||(e=f[_DYN_CORE].getPlugin(PropertiesPluginIdentifier))&&(e=e.plugin.context)&&(t=createDistributedTraceContextFromTrace(e.telemetryTrace)),(e=t)&&(e.setTraceId(generateW3CId()),t="_unknown_",n&&n.pathname&&(t=n.pathname+(n.hash||"")),e.setName(dataSanitizeString(f[_DYN_DIAG_LOG](),t))),scheduleTimeout((function(e){f[_DYN_TRACK_PAGE_VIEW]({refUri:e,properties:{duration:0}})}).bind(f,U),f.autoRoutePVDelay))},G),A=!0)))})))}catch(N){throw f.setInitialized(!1),N}var i,_,s,c,u,l,E}},f._doTeardown=function(e,t){S&&S.teardown(e,t),eventOff(window,null,null,G),n()},f._getDbgPlgTargets=function(){return[w,C]},objDefine(f,"_pageViewManager",{g:function(){return S}}),objDefine(f,"_pageViewPerformanceManager",{g:function(){return p}}),objDefine(f,"_pageVisitTimeManager",{g:function(){return m}}),objDefine(f,"_evtNamespace",{g:function(){return"."+G}})}),e}return __extendsFn(n,t),n.Version="3.3.8",n}(BaseTelemetryPlugin);exports.AnalyticsPlugin=AnalyticsPlugin,exports.ApplicationInsights=AnalyticsPlugin;
//# sourceMappingURL=applicationinsights-analytics-js.cjs.min.js.map
